/*      cbignum.cpp

	 ᫠  ࠭祭 ࠧ來 ⪮.
	 権.

	(C) ..஢,   PAH, 1999 - 2000
	All Rights Reserved.
*/
#if __TURBOC__ > 0x410
#pragma option -xd-
#endif
#include <ctype.h>
#include <stdlib.h>
#include <iomanip.h>
#include <limits.h>
#include "cbignum.h"
#include <assert.h>

#define	BITS		(CHAR_BIT * sizeof (long))

//================================================
//	㦥 ६.
//================================================

//	 ६  ᪨  
//	⮣, ⮡ ᪫  室  ᮧ
//	६ ꥪ⮢  ६ 믮 ⮤,
//	᪨  窨 ७ ந⥫쭮.
//	,    ६,  ᢮.
//	⮬        ୠ ६
//	 ᯮ짮 ࠧ ᪮쪨 ⮤.
//	⮤, ᯮ騥      ६,
//	  뢠  㣠,  ᪫祭  砥,
//	 ୠ ६ ᯮ  । ࠭.

static	cBigNumber	_a;		//  ᭮  ⥯.
static	cBigNumber	_b;		//  ⥫ ⥯.
static	cBigNumber	_num;		//   ᫥ (⮤
					// ᤢ, ⥯).

//	⮪  ᫥  ନ ᥬ ⮤
//	,   䥪 ਬ塞 ⬠.

cBigNumber cBigNumberLastDivMod;	// ⮪  ᫥ .

//	⥪ ६ ꥪ⮢.

exblockstack<long> cBigTemp::stack;

//================================================
//	 孮᪨ ८ࠧ.
//================================================

cBigNumber& cBigNumber::fit()
{
  cBigNumberFit (EXPTRTYPE(*this));
  return *this;  
}

cBigNumber& cBigNumber::tab()
{
  checkexpand ((length() + 2) * BITS);
  cBigNumberTab (EXPTRTYPE(*this));
  return *this;  
}

//================================================
//	 㭠 権  .
//================================================

cBigNumber& cBigNumber::operator ++ ()
{
  checkexpand (length() + 1); checksize (cBigNumberMInc (EXPTRTYPE(*this)));
  return *this;
}

cBigNumber& cBigNumber::operator -- ()
{
  checkexpand (length() + 1); checksize (cBigNumberMDec (EXPTRTYPE(*this)));
  return *this;
}

cBigNumber& cBigNumber::mul2 ()
{
  checkexpand (length() + 1);
  checksize (cBigNumberMMul2 (EXPTRTYPE(*this)));
  return *this;
}

cBigNumber& cBigNumber::div2 ()
{
  checksize (cBigNumberMDiv2 (EXPTRTYPE(*this)));
  return *this;
}

cBigNumber& cBigNumber::pow2 ()
{
  checkexpand (length() * 2 + 1);
  cBigNumberMul (EXPTRTYPE(*this), EXPTRTYPE(*this), EXPTRTYPE(*this));
  checksize (length());
  return *this;
}

//================================================
//	 権 ᢠ.
//================================================
  
cBigNumber& cBigNumber::setxor (const cBigNumber& a, const cBigNumber& b)
{
  checksize ((a.length() >= b.length())?
	(checkexpand (a.length()), cBigNumberXor (EXPTRTYPE(a), EXPTRTYPE(b), EXPTRTYPE(*this))):
	(checkexpand (b.length()), cBigNumberXor (EXPTRTYPE(b), EXPTRTYPE(a), EXPTRTYPE(*this))));
  return *this;
}

cBigNumber& cBigNumber::setxor (const cBigNumber& a, long b)
{
  checkexpand (a.length());
  checksize (cBigNumberXor (EXPTRTYPE(a), EXPTRTYPE(_cBigLong(b)), EXPTRTYPE(*this)));
  return *this;
}

cBigNumber& cBigNumber::setxor (long a, const cBigNumber& b)
{
  checkexpand (b.length());
  checksize (cBigNumberXor (EXPTRTYPE(b), EXPTRTYPE(_cBigLong(a)), EXPTRTYPE(*this)));
  return *this;
}

cBigNumber& cBigNumber::setxor (long a, long b)
{
  *this = a ^ b;
  return *this;
}

cBigNumber& cBigNumber::setand (const cBigNumber& a, const cBigNumber& b)
{
  checksize ((a.length() >= b.length())?
	(checkexpand (a.length()), cBigNumberAnd (EXPTRTYPE(a), EXPTRTYPE(b), EXPTRTYPE(*this))):
	(checkexpand (b.length()), cBigNumberAnd (EXPTRTYPE(b), EXPTRTYPE(a), EXPTRTYPE(*this))));
  return *this;
}

cBigNumber& cBigNumber::setand (const cBigNumber& a, long b)
{
  checkexpand (a.length());
  checksize (cBigNumberAnd (EXPTRTYPE(a), EXPTRTYPE(_cBigLong(b)), EXPTRTYPE(*this)));
  return *this;
}

cBigNumber& cBigNumber::setand (long a, const cBigNumber& b)
{
  checkexpand (b.length());
  checksize (cBigNumberAnd (EXPTRTYPE(b), EXPTRTYPE(_cBigLong(a)), EXPTRTYPE(*this)));
  return *this;
}

cBigNumber& cBigNumber::setand (long a, long b)
{
  *this = a & b;
  return *this;
}

cBigNumber& cBigNumber::setor  (const cBigNumber& a, const cBigNumber& b)
{
  checksize ((a.length() >= b.length())?
	(checkexpand (a.length()), cBigNumberOr (EXPTRTYPE(a), EXPTRTYPE(b), EXPTRTYPE(*this))):
	(checkexpand (b.length()), cBigNumberOr (EXPTRTYPE(b), EXPTRTYPE(a), EXPTRTYPE(*this))));
  return *this;
}

cBigNumber& cBigNumber::setor  (const cBigNumber& a, long b)
{
  checkexpand (a.length());
  checksize (cBigNumberOr (EXPTRTYPE(a), EXPTRTYPE(_cBigLong(b)), EXPTRTYPE(*this)));
  return *this;
}

cBigNumber& cBigNumber::setor  (long a, const cBigNumber& b)
{
  checkexpand (b.length());
  checksize (cBigNumberOr (EXPTRTYPE(b), EXPTRTYPE(_cBigLong(a)), EXPTRTYPE(*this)));
  return *this;
}

cBigNumber& cBigNumber::setor  (long a, long b)
{
  *this = a | b;
  return *this;
}

cBigNumber& cBigNumber::setadd (const cBigNumber& a, const cBigNumber& b)
{
  checksize ((a.length() >= b.length())?
	(checkexpand (a.length() + 1), cBigNumberAdd (EXPTRTYPE(a), EXPTRTYPE(b), EXPTRTYPE(*this))):
	(checkexpand (b.length() + 1), cBigNumberAdd (EXPTRTYPE(b), EXPTRTYPE(a), EXPTRTYPE(*this))));
  return *this;
}

cBigNumber& cBigNumber::setadd (const cBigNumber& a, long b)
{  
  checkexpand (a.length() + 1);
  checksize (cBigNumberAdd (EXPTRTYPE(a), EXPTRTYPE(_cBigLong(b)), EXPTRTYPE(*this)));
  return *this;
}

cBigNumber& cBigNumber::setadd (long a, const cBigNumber& b)
{  
  checkexpand (b.length() + 1);
  checksize (cBigNumberAdd (EXPTRTYPE(b), EXPTRTYPE(_cBigLong(a)), EXPTRTYPE(*this)));
  return *this;
}

cBigNumber& cBigNumber::setadd (long a, long b)
{  
  checkexpand (2);
  checksize (cBigNumberAdd (EXPTRTYPE(_cBigLong(a)), EXPTRTYPE(_cBigLong(b)), EXPTRTYPE(*this)));
  return *this;
}

cBigNumber& cBigNumber::setsub (const cBigNumber& a, const cBigNumber& b)
{
  checksize ((a.length() >= b.length())?
	(checkexpand (a.length() + 1), cBigNumberSub  (EXPTRTYPE(a), EXPTRTYPE(b), EXPTRTYPE(*this))):
	(checkexpand (b.length() + 1), cBigNumberSubS (EXPTRTYPE(b), EXPTRTYPE(a), EXPTRTYPE(*this))));
  return *this;
}

cBigNumber& cBigNumber::setsub (const cBigNumber& a, long b)
{
  checkexpand (a.length() + 1);
  checksize (cBigNumberSub  (EXPTRTYPE(a), EXPTRTYPE(_cBigLong(b)), EXPTRTYPE(*this)));
  return *this;
}

cBigNumber& cBigNumber::setsub (long a, const cBigNumber& b)
{
  checkexpand (b.length() + 1);
  checksize (cBigNumberSubS (EXPTRTYPE(b), EXPTRTYPE(_cBigLong(a)), EXPTRTYPE(*this)));
  return *this;
}

cBigNumber& cBigNumber::setsub (long a, long b)
{
  checkexpand (2);
  checksize (cBigNumberSub  (EXPTRTYPE(_cBigLong(a)), EXPTRTYPE(_cBigLong(b)), EXPTRTYPE(*this)));
  return *this;
}

cBigNumber& cBigNumber::setmul (const cBigNumber& a, const cBigNumber& b)
{
  checkexpand (a.length() + b.length() + 1);
  if (a.length() >= b.length())
	cBigNumberMul (EXPTRTYPE(a), EXPTRTYPE(b), EXPTRTYPE(*this));
  else	cBigNumberMul (EXPTRTYPE(b), EXPTRTYPE(a), EXPTRTYPE(*this));
  checksize (length());
  return *this;
}

cBigNumber& cBigNumber::setmul (const cBigNumber& a, long b)
{
  checkexpand (a.length() + 2);
  cBigNumberMul (EXPTRTYPE(a), EXPTRTYPE(_cBigLong(b)), EXPTRTYPE(*this));
  checksize (length());
  return *this;
}

cBigNumber& cBigNumber::setmul (long a, const cBigNumber& b)
{
  checkexpand (b.length() + 2);
  cBigNumberMul (EXPTRTYPE(b), EXPTRTYPE(_cBigLong(a)), EXPTRTYPE(*this));
  checksize (length());
  return *this;
}

cBigNumber& cBigNumber::setmul (long a, long b)
{
  checkexpand (3);
  cBigNumberMul (EXPTRTYPE(_cBigLong(a)), EXPTRTYPE(_cBigLong(b)), EXPTRTYPE(*this));
  checksize (length());
  return *this;
}

cBigNumber& cBigNumber::setdiv (const cBigNumber& a, const cBigNumber& b)
{
  checkexpand (a.length() + 1);
  cBigNumberLastDivMod = a;
  cBigNumberDiv (EXPTRTYPE(cBigNumberLastDivMod), EXPTRTYPE(b), EXPTRTYPE(*this));
  checksize (length());
  return *this;
}

cBigNumber& cBigNumber::setdiv (const cBigNumber& a, long b)
{
  checkexpand (a.length() + 1);
  cBigNumberLastDivMod = a;
  cBigNumberDiv (EXPTRTYPE(cBigNumberLastDivMod), EXPTRTYPE(_cBigLong(b)), EXPTRTYPE(*this));
  checksize (length());
  return *this;
}

cBigNumber& cBigNumber::setdiv (long a, const cBigNumber& b)
{
  checkexpand (2);
  cBigNumberLastDivMod = a;
  cBigNumberDiv (EXPTRTYPE(cBigNumberLastDivMod), EXPTRTYPE(b), EXPTRTYPE(*this));
  checksize (length());
  return *this;
}

cBigNumber& cBigNumber::setdiv (long a, long b)
{
  checkexpand (2);
  cBigNumberLastDivMod = a;
  cBigNumberDiv (EXPTRTYPE(cBigNumberLastDivMod), EXPTRTYPE(_cBigLong(b)), EXPTRTYPE(*this));
  checksize (length());
  return *this;
}

cBigNumber& cBigNumber::setmod (const cBigNumber& a, const cBigNumber& b)
{
  *this = a; *this %= b;
  return *this;
}

cBigNumber& cBigNumber::setmod (const cBigNumber& a, long b)
{
  *this = a; *this %= b;
  return *this;
}

cBigNumber& cBigNumber::setmod (long a, const cBigNumber& b)
{
  *this = a; *this %= b;
  return *this;
}

cBigNumber& cBigNumber::setmod (long a, long b)
{
  *this = a % b;
  return *this;
}

//================================================
//	 ᤢ.
//================================================

//	᪨  ६.
 
cBigNumber& cBigNumber::operator <<= (const cBigNumber& b)
{
  if (b.hiword() < 0) return (*this >>= (-b));
  _num.setdiv (b, BITS);
  size_t n = (size_t) cBigNumberLastDivMod.loword();	//   .
  checkexpand ((_num.length() <= 1 &&
	     (unsigned long)_num.loword() < UINT_MAX-length())?
	    length() + (size_t)_num.loword() + 1: UINT_MAX);
  for (; n > 0; --n)  cBigNumberMMul2 (EXPTRTYPE(*this));
  cBigNumberCopyShl (EXPTRTYPE(*this), (size_t)_num.loword(), EXPTRTYPE(*this));
  return *this;
}

cBigNumber& cBigNumber::operator <<= (long b)
{
  if (b < 0) return (*this >>= (-b));
  size_t n = (size_t) b % BITS; b /= BITS;
  checkexpand ((unsigned long)b < UINT_MAX-length()?
            length() + (size_t)b + 1: UINT_MAX);
  for (; n > 0; --n) cBigNumberMMul2 (EXPTRTYPE(*this));
  cBigNumberCopyShl (EXPTRTYPE(*this), (size_t)b, EXPTRTYPE(*this));
  return *this;
}

cBigNumber& cBigNumber::setshl (const cBigNumber& a, const cBigNumber& b)
{
  *this = a; return *this <<= b;
}

cBigNumber& cBigNumber::setshl (const cBigNumber& a, long b)
{
  *this = a; return *this <<= b;
}

cBigNumber& cBigNumber::setshl (long a, const cBigNumber& b)
{
  *this = a; return *this <<= b;
}

cBigNumber& cBigNumber::setshl (long a, long b)
{
  *this = a; return *this <<= b;
}

cBigNumber& cBigNumber::operator >>= (const cBigNumber& b)
{
  if (b.hiword() < 0) return (*this <<= (-b));
  _num.setdiv (b, BITS);
  size_t n = (size_t) cBigNumberLastDivMod.loword();
  for (; n > 0; --n)  cBigNumberMDiv2 (EXPTRTYPE(*this));
  cBigNumberCopyShr (EXPTRTYPE(*this),
	((_num.length() <= 1 && (unsigned long)_num.loword() <= UINT_MAX)?
	 (size_t)_num.loword(): UINT_MAX),
	EXPTRTYPE(*this));
  return *this;
}

cBigNumber& cBigNumber::operator >>= (long b)
{
  if (b < 0) return (*this <<= (-b));
  size_t n = (size_t) b % BITS; b /= BITS;
  for (; n > 0; --n) cBigNumberMDiv2 (EXPTRTYPE(*this));
  cBigNumberCopyShr (EXPTRTYPE(*this),
	(((unsigned long)b <= UINT_MAX)? (size_t)b: UINT_MAX), EXPTRTYPE(*this));
  return *this;
}

cBigNumber& cBigNumber::setshr (const cBigNumber& a, const cBigNumber& b)
{
  *this = a; return *this >>= b;
}

cBigNumber& cBigNumber::setshr (const cBigNumber& a, long b)
{
  *this = a; return *this >>= b;
}

cBigNumber& cBigNumber::setshr (long a, const cBigNumber& b)
{
  *this = a; return *this >>= b;
}

cBigNumber& cBigNumber::setshr (long a, long b)
{
  *this = a; return *this >>= b;
}

//================================================
//	   ⥯.
//================================================

//	  ⥯.

cBigNumber& cBigNumber::_setpow ()		// ਢ ⮤.
{
  if (_b.hiword() < 0)				// ⥫쭠 ⥯.
  {
   _a.setdiv (1,_a); _b.neg();
  }
  _num.setmul (_b, _a.bits());			// 業 ࠧ १.
  size_t n = (
	(_num.length() <= 1 && (unsigned long)_num.loword() <= UINT_MAX)?
	(size_t)(_num.loword() / BITS + 2): UINT_MAX);
  checkexpand (n); _a.checkexpand (n);
  cBigNumberPow (EXPTRTYPE(_a), EXPTRTYPE(_b), EXPTRTYPE(*this));
  checksize (length());
  return *this;
}

cBigNumber& cBigNumber::setpow (const cBigNumber& a, const cBigNumber& b)
{
  _a = a; _b = b; return _setpow ();
}

cBigNumber& cBigNumber::setpow (const cBigNumber& a, long b)
{
  _a = a; _b = b; return _setpow ();
}

cBigNumber& cBigNumber::setpow (long a, const cBigNumber& b)
{
  _a = a; _b = b; return _setpow ();
}              

cBigNumber& cBigNumber::setpow (long a, long b)
{
  _a = a; _b = b; return _setpow ();
}

//	  ⥯   .

cBigNumber& cBigNumber::_setpowmod (const cBigNumber &mod)
{
  if (_b.hiword() < 0)				// ⥫쭠 ⥯.
  {
    _a.setdiv (1,_a); _b.neg();
  }
  size_t n = mod.length() * 2 + 1;      	//  .
  checkexpand (n); _a.checkexpand (n);
  cBigNumberPowMod (EXPTRTYPE(_a), EXPTRTYPE(_b), EXPTRTYPE(mod), EXPTRTYPE(*this));
  checksize (length());
  return *this;
}

cBigNumber& cBigNumber::setpowmod (const cBigNumber& a, const cBigNumber& b,
			           const cBigNumber& mod)
{
  _a.setmod (a, mod); _b.setmod (b, mod); return _setpowmod (mod);
}

cBigNumber& cBigNumber::setpowmod (const cBigNumber& a, long b,
			           const cBigNumber& mod)
{
  _a.setmod (a, mod); _b.setmod (b, mod); return _setpowmod (mod);
}

cBigNumber& cBigNumber::setpowmod (long a, const cBigNumber& b,
			           const cBigNumber& mod)
{
  _a.setmod (a, mod); _b.setmod (b, mod); return _setpowmod (mod);
}

cBigNumber& cBigNumber::setpowmod (long a, long b,
			           const cBigNumber& mod)
{
  _a.setmod (a, mod); _b.setmod (b, mod); return _setpowmod (mod);
}

//	  ⥯  ⪮ .

cBigNumber& cBigNumber::_setpowmod (long mod)
{
  if (_b.hiword() < 0)				// ⥫쭠 ⥯.
  {
   _a.setdiv (1,_a); _b.neg();
  }
  checkexpand (2); _a.checkexpand (2);
  cBigNumberPowMod (EXPTRTYPE(_a), EXPTRTYPE(_b), EXPTRTYPE(_cBigLong(mod)), EXPTRTYPE(*this));
  checksize (length());
  return *this;
}

cBigNumber& cBigNumber::setpowmod (const cBigNumber& a, const cBigNumber& b,
			           long mod)
{
  _a.setmod (a, mod); _b.setmod (b, mod); return _setpowmod (mod);
}

cBigNumber& cBigNumber::setpowmod (const cBigNumber& a, long b,
			           long mod)
{
  _a.setmod (a, mod); _b.setmod (b, mod); return _setpowmod (mod);
}

cBigNumber& cBigNumber::setpowmod (long a, const cBigNumber& b,
			           long mod)
{
  _a.setmod (a, mod); _b.setmod (b, mod); return _setpowmod (mod);
}

cBigNumber& cBigNumber::setpowmod (long a, long b,
			           long mod)
{
  _a.setmod (a, mod); _b.setmod (b, mod); return _setpowmod (mod);
}

//================================================
//	 権  ⠡楩 ᤢ.
//================================================

cBigNumber& cBigNumber::setdivtab (const cBigNumber& a, const cBigNumber& b)
{
  checkexpand (a.length() + 1);
  cBigNumberLastDivMod = a;
  cBigNumberDivTab (EXPTRTYPE(cBigNumberLastDivMod), EXPTRTYPE(b), EXPTRTYPE(*this));
  checksize (length());
  return *this;
}

cBigNumber& cBigNumber::setdivtab (long a, const cBigNumber& b)
{
  checkexpand (2);
  cBigNumberLastDivMod = a;
  cBigNumberDivTab (EXPTRTYPE(cBigNumberLastDivMod), EXPTRTYPE(b), EXPTRTYPE(*this));
  checksize (length());
  return *this;
}

cBigNumber& cBigNumber::setmodtab (const cBigNumber& a, const cBigNumber& b)
{
  *this = a;
  cBigNumberMModTab (EXPTRTYPE(*this), EXPTRTYPE(b));
  checksize (length());
  return *this;
}

cBigNumber& cBigNumber::setmodtab (long a, const cBigNumber& b)
{
  *this = a;
  cBigNumberMModTab (EXPTRTYPE(*this), EXPTRTYPE(b));
  checksize (length());
  return *this;
}

//================================================
//	 ஢ 権.
//================================================

cBigNumber& cBigNumber::addmul (const cBigNumber& a, const cBigNumber& b)
{
  checkexpand (a.length() + b.length() + 1);
  checkexpand (length() + 1); 
  if (a.length() >= b.length())
	cBigNumberMAddMul (EXPTRTYPE(a), EXPTRTYPE(b), EXPTRTYPE(*this));
  else	cBigNumberMAddMul (EXPTRTYPE(b), EXPTRTYPE(a), EXPTRTYPE(*this));
  checksize (length());
  return *this;
}

cBigNumber& cBigNumber::addmul (const cBigNumber& a, long b)
{
  checkexpand (a.length() + 2);
  checkexpand (length() + 1); 
  cBigNumberMAddMul (EXPTRTYPE(a), EXPTRTYPE(_cBigLong(b)), EXPTRTYPE(*this));
  checksize (length());
  return *this;
}

cBigNumber& cBigNumber::addmul (long a, const cBigNumber& b)
{
  checkexpand (b.length() + 2);
  checkexpand (length() + 1); 
  cBigNumberMAddMul (EXPTRTYPE(b), EXPTRTYPE(_cBigLong(a)), EXPTRTYPE(*this));
  checksize (length());
  return *this;
}

cBigNumber& cBigNumber::addmul (long a, long b)
{
  checkexpand (3);
  checkexpand (length() + 1); 
  cBigNumberMAddMul (EXPTRTYPE(_cBigLong(a)), EXPTRTYPE(_cBigLong(b)), EXPTRTYPE(*this));
  checksize (length());
  return *this;
}

//================================================
//	    ᫠.
//================================================

//	Strong Probable Primarity test for base b
//	by Olivier Langlois <olanglois@sympatico.ca>
//	뤠:
//	0 - ⠢
//	2 - , ⮥

int	b_SPRP	(
	const cBigNumber& n,		// 㥬 ᫮
	const cBigNumber& b		// .
)
{
  if (n < 2) return 0;
  static cBigNumber t;
  static cBigNumber nMinus1;
  static cBigNumber a;
  t = nMinus1 = n - 1; a = 0;

//                                	      a
//	Find t and a satisfying: n - 1 = t * 2 , t odd
//

  while( !(t.loword() & 1) ) { t >>= 1; ++a; }

//	We check the congruence class of      i
//					 t * 2
//					b       % n
//	for each i from 0 to a - 1.
//	If any one is correct, then n passes.
//	Otherwise, n fails.
   
  cBigNumber test; test.setpowmod (b, t, n);
   
  if (test == 1 || test == nMinus1) return 2;
  
  if (a)
  {
    while (--a)
    {
      test.pow2(); test %= n; if (test == nMinus1) return 2;
    }
  }
   
  return 0;
}
