/*	cbignumf.cpp

	 ᫠  ࠭祭 ࠧ來 ⪮.
	㦥 㭪樨.

	(C) ..஢,   PAH, 1999 - 2000
	All Rights Reserved.
*/
#include <ctype.h>
#include <stdlib.h>
#include <iomanip.h>
#include <limits.h>
#include "cbignum.h"
#include <assert.h>

#define	BITS	(CHAR_BIT * sizeof (long))

#ifdef __cplusplus
extern "C" {
#endif

//================================================
//	 権  ᫠ cBigNumber.
//================================================
//	樨 ॠ   㭪権 몠 C.
//
// 	 ᫠ । १ யࠬ EXPTR(long):
//	 long *  ࠡ祬 ०  exptr<long>  ⫠筮
//	०  ஢મ 室   ࠭ ᨢ.
//      室 ᫠   먪஬ const.
//	 㭪樨  ᮮࠦ ⨬樨  
//	 ᫠ ᫮  १饬 ᫥;  ⮣
//	᫮ ᫮ 뤠  ⢥ 祭 ⨯ size_t.
//	 ⠪ 㭪権 稭   ન;
//	 ᮯ஢ ᮬ, 뢠騬 㭪 
//	騬  ᫠ ᫮.
//
//	᪨ ஫ 室 
//	ࠢ ᫥騬 ᠬ:
//	NDEBUG    - ⪫砥 ஫ 室 㪠⥫
//		     ࠭ ᨢ  ஫ 訡
//		     室 ࠬ 㭪権.
//		    室 㪠⥫  ࠭ ᨢ
//	NCHECKPTR - ⪫砥 ஫ 室 㪠⥫
//		     ࠭ ᨢ.
//
//	  㭪 cBigNumber... ⨬஢
//	 ⥬, ⮡ ᮪ ᫮ ஢ப  室
//	 ࠡ⪥ ᫮ ᥫ.
//	冷 믮 権 ࠭, 室
//	 ᮮࠦ ⨬쭮 㪨 ஢
//	 Pentium.

//================================================
//	ଠ樮 㭪樨.
//================================================

//	 楫 ᫮ ࠭  ᨢ ⨯ long.
//	 ᨢ  㫥 ᮬ ᮤন ᫮ long-᫮,
//	ॡ㥬  ।⠢  ᫠  ⥫쭮
//	筮 ,  ᫥  - ᠬ  ᫠,
//	 浪   ࠧ冷  訬.
//	 ᫠ 室  ᫥ ᫮.

//      뢮 ७ ।⠢ 믮  ⮪
//	cout  浪   ᫮  訬.  ᫮
//	। ஡  뢮  ⭠筮
//	।⠢,  浪   ࠧ冷  訬.
//	뢮 ᫮ 蠥 ॢ ப.

void	cBigNumberDump (			// ⫠筠 ᯥ⪠.
		const	EXPTR(long) p1		//  ᫮.
	)
{
  char fill  = cout.fill  ('0');		// ⥫.
  long flags = cout.flags (ios::hex);		// ⭠ 뢮.

  size_t n1 = (size_t)(*p1);         		// ᫮ ᫮.
  for (; n1; n1--) cout <<" "<< setw(8) << (unsigned long) p1 [n1];
  cout << endl;

  cout.fill  (fill);				// ०  ⥫.
  cout.flags (flags);				// ० 䫠.
}

//	  ⥫쭮  ᯮ 쭮
//	 ᫮ long-᫮,     ᫮:
//	- ᫨ ᫮ ᫮  1,  襥 ᫮ ⫨砥 
//	  १ ७ 襣  ।᫥ ᫮;
//	-  ।⠢  㫥 ᫮.
//	 ।⠢  㤥 뢠 ଠ.

int	cBigNumberIsFit (			// ஢ઠ ଠ.
		const	EXPTR(long) p1		//  ᫮.
	)					// ᫨ ᫮ ଠ,
{						//  뤠 1  0.
  size_t n1 = (size_t)(*p1);           		// ᫮ ᫮.
  if (n1)
  {
    if (n1 > 1) return ((p1 [n1] != (p1 [n1-1] >> (BITS-1))));
  }
  return (n1);					// ᫮ ᫮ 0.
}

//	 業 ࠧ來 ᫠ । ᫮  .
//	騬 ⠥ ᠬ 訩 , ⫨  
//	ࠧ鸞   訥  ⭮襭   .
//	ਬ,  0  -1   , 1  -2  1 騩 ,
//	᫠ 127  -128  7  .
//	 ᫠  n 騬 ⠬  ॢ室 2  ⥯ n.
//	  ਠ 㭪樨:     ᥫ.

int	cBigNumberBits (			// ᫮  .
		const	EXPTR(long) p1		//  ᫮.
	)	// ᫮ ⢥砥 ᫮ pow(2,n) >= abs(p1).
		// ᫨ ᫮   INT_MAX,  뤠 INT_MAX.
{
  size_t n1 = (int)(*p1);			// ᫮ ᫮.
  if (n1)
  {
    long sign = p1 [n1];			// .
    do
    {
      unsigned long num = p1 [n1];		// 饥 ᫮.
      if (sign < 0) num = ~num;			// ⥫쭮 ᫮.
      if (num)					//  騥 ?
      {
        if (n1 <= (INT_MAX / BITS))
        {
          n1 *= BITS;				// ᫮   ᫮.
          if (num < (1L<<(BITS/2)))           	//  1- 饣 .
          {
	    n1 -= BITS; do ++n1; while ((num >>= 1) > 0);
          }
          else if ((long)num > 0)
          {
	    do --n1; while ((long)(num <<= 1) > 0);
          }
	}
        else n1 = INT_MAX;			// ९.
        break;					//  横.
      }
    }
    while (--n1 != 0);
  }
  return (n1);
}

int	cLongBits (long num)			// ᫮  .
{
  int n1 = BITS;
  if (num < 0) num = ~num;			// ⥫쭮 ᫮.
  if (num >= (1L<<(BITS/2))) 	          	//  ⮢  ᫮.
    do --n1; while ((num <<= 1) > 0);
  else
  {
    n1 -= BITS; if (num) do ++n1; while ((num >>= 1) > 0);
  }
  return (n1);
}

//================================================
//	㭪樨 ࠢ.
//================================================

//	 ࠢ  ᥫ   ࠧ  
//	⠪, ⮡  ᫠ ᮤঠ max(n1,n2) ᫮.
//	祭 ᫮ ࠢ ᫮  浪 
//	 ᫮  訬  ࢮ ᮢ.
//	ࠢ  ᫮ - , ࠢ
//	⠫ ᫮ - .

//	 楫 ⨬樨  䠪᪮ ७
//	 ࠧ鸞 ਬ ⬨᪨ .

int	cBigNumberComp  (			// ࠢ p1  p2.
		const	EXPTR(long) p1,		// ᫮.
		const	EXPTR(long) p2		// ᫮.
	)					// 뤠 -1  p1 <  p2
						// 뤠  0  p1 == p2
						// 뤠  1  p1  > p2
{
  size_t n1 = (size_t)(*p1);			// ᫮ ᫮  p1.
  size_t n2 = (size_t)(*p2);			// ᫮ ᫮  p2.
  register long lp1 = 0;			// 饥 ᫮ p1.
  register long lp2 = 0;			// 饥 ᫮ p2.
//
//	ࠢ  ᫮.
//
  if (n1) lp1 = p1 [n1--];			//  ᫮ p1.
  if (n2) lp2 = p2 [n2--];			//  ᫮ p2.

  if (n1 == n2)					//  p1  p2 ᮢ.
  {
    if (lp1 != lp2) goto NotSameSignWord;	//  ᫮  ᮢ.
  }
  else if (n1 > n2)				// ᫨ ᫮ p1 , 
  {						// ஢ ࠢ 
    lp2 >>= (BITS-1); ++n2;			// ७  p2.
    if (lp1 != lp2) goto NotSameSignWord;	//  ᫮  ᮢ.
    if (n1 > n2)				// ࠢ  ᫮.
    {
      do					//  ࠢ.
      {
	lp1 = p1 [n1]; --n1;			// ⥭ ᫮.
	if (lp1 != lp2) goto NotSame;		//   ᮢ.
      }
      while (n1 > n2);				//  横 ࠢ.
    }
  }
  else // (n1 < n2)				// ᫨ ᫮ p2 , 
  {						// ஢ ࠢ 
    lp1 >>= (BITS-1); ++n1;			// ७  p1.
    if (lp1 != lp2) goto NotSameSignWord;	//  ᫮  ᮢ.
    if (n1 < n2)				// ࠢ  ᫮.
    {
      do					//  ࠢ.
      {
	lp2 = p2 [n2]; --n2;			// ⥭ ᫮.
	if (lp1 != lp2) goto NotSame;		//   ᮢ.
      }
      while (n1 < n2);				//  横 ࠢ.
    }
  }
//
//	୮ ࠢ  ᫮.
//
  if (n1)
  {
    do						//  ࠢ.
    {
      lp1 = p1 [n1]; lp2 = p2 [n1]; --n1;	// ⥭ ᫮.
      if (lp1 != lp2) goto NotSame;    	  	//   ᮢ.
    }
    while (n1);					//  横 ࠢ.
  }

  return (0);					// 祭 ᮢ.
NotSame:                     		  	// 祭  ᮢ.
  return ((((unsigned long)lp1) >= (unsigned long)lp2) * 2 - 1);
NotSameSignWord:                               	//  ᮢ  ᫮.
  return ((lp1 >= lp2) * 2 - 1);
}

//	樠஢ ࠢ  .
//	।,  ᫠ ଠ  ࠧ ࢮ
//	᫠   ࠧ ண ᫠.
//	訥 ᫮ ࢮ ᫠ ࠢ   ᫮.

int	cBigNumberCompHigh (			// ࠢ   ᫮.
		const	EXPTR(long) p1,		// ᫮.
		const	EXPTR(long) p2		// ᫮.
	)					// 뤠 -1  p1 <  p2
						// 뤠  0  p1 == p2
						// 뤠  1  p1  > p2
{
  size_t n1 = (size_t)(*p1);			// ᫮ ᫮  p1.
  size_t n2 = (size_t)(*p2);			// ᫮ ᫮  p2.
  assert (n1 >= n2);				// ஢ઠ ࠧ.
  assert (n2 > 0);				// ஢ઠ ࠧ.
//
//	ࠢ  ᫮.
//
  register long lp1 = p1 [n1--];		// 饥 ᫮ p1.
  register long lp2 = p2 [n2--];		// 饥 ᫮ p2.
  if (lp1 != lp2) return ((lp1 >= lp2) * 2 - 1);//   ᮢ.
//
//	୮ ࠢ  ᫮.
//
  if (n2)
  {
    do						//  ࠢ.
    {
      lp1 = p1 [n1--]; lp2 = p2 [n2--];		// ⥭ ᫮.
      if (lp1 != lp2)		    	  	//   ᮢ.
	return ((((unsigned long)lp1) >= (unsigned long)lp2) * 2 - 1);
    }
    while (n2);					//  横 ࠢ.
  }

  return (0);					// 祭 ᮢ.
}

//	樠஢ ࠢ c 0.
//	 ⨬஢  ᪫祭 ᫮ 室.
//	 ࠡ⠥ ⮫쪮  ଠ ᥫ.
//	뤠 ⮢ 㬬  ᫮  ᫮ ᫮,
//	  2 (  ⥫쭮 ᫠ 
//	᫮   㫥,  ⮣ ᫮ ᫮ > 1).

inline	long	cBigNumberNot0	(const EXPTR(long) p1)	// ࠢ  0:
{							//  0  p1 = 0
  size_t n1 = (size_t)(*p1);				//   ⫨筮  0
  return (p1 [n1] | (long)(n1 >> 1));
}


//================================================
//	㭪樨 ஢  ⮢ ᨨ.
//================================================

void	cBigNumberCopy (			// ஢ p = p1.
		const	EXPTR(long) p1,		// 㥬 ᫮.
			EXPTR(long) p		//  ࠧ *p1 + 1.
	)					// p1  p  ᮢ.
{
  size_t n1 = (size_t)(*p++ = *p1++); 		// ᫮ ᫮.
  if (n1)
  do						//  ஢ ᫮.
    { *p++ = *p1++; }				// ஢ ᫮.
  while (--n1 != 0);   				//  横 ஢.
}

void	cBigNumberCompl (			//  p = ~p1.
			const EXPTR(long) p1,	// 㥬 ᫮.
			EXPTR(long) p		//  ࠧ *p1 + 1.
	)					// p1  p  ᮢ.
{
  size_t n1 = (size_t)(*p++ = *p1++); 		// ᫮ ᫮.
  if (n1)
  do						//  ஢ ᫮.
    { *p++ = ~*p1++; }				// ஢ ᫮.
  while (--n1 != 0);   				//  横 ஢.
}

//================================================
//	㭪樨 ᤢ   ᫮ ᫮.
//================================================

//	  ᮯ஢ 㢥祭 ᫠ ᫮,
//	᫨ ⮫쪮 ᤢ ᫮  ࠢ 0.
//	 ⥭ 㬭  2  ⥯ (BITS * k1).

void	cBigNumberCopyShl (			//  p = p1<<(BITS*k1).
		const	EXPTR(long) p1,		//  ᫮.
			size_t	    k1,		// ⥫ ᤢ.
			EXPTR(long) p		//  ࠧ *p1 + k1 + 1.
	)					// p1  p  ᮢ.
{
  size_t n1 = (size_t)(*p1);			// ᫮ ᫮.
  if (n1 <= 1 && p1 [n1] == 0) k1 = 0;		// 㫥 ᫮.
  p1 += n1; *p = n1 + k1; p += (n1 + k1);
  if (n1)
  do						//  ஢ ᫮.
    { *p-- = *p1--; }				// ஢ ᫮.
  while (--n1 != 0);        			//  横 ஢.
  if (k1)					
  do						//  㫥 ᫮.  
    { *p-- = 0; }				// 㫥 ᫮.      
  while (--k1 != 0);				//  横 㫥.
}

//	 ࠢ 믮  ࠭  ᫠.
//	 ⥭   2  ⥯ (BITS * k1).

void	cBigNumberCopyShr (			//  p = p1>>(BITS*k1).
		const	EXPTR(long) p1,		// 㥬 ᫮.
			size_t	    k1,		// ⥫ ᤢ.
			EXPTR(long) p		//  ࠧ *p1 - k1 + 1.
	)					// p1  p  ᮢ.
{
  size_t n1 = (size_t)(*p1);			// ᫮ ᫮,
  if (n1 > k1)					// ॡ ஢.
  {
    p1 += (k1 + 1);				// .
    *p++ = (n1 -= k1);				// ᫮ ᫮.
    do						//  ஢ ᫮.
      { *p++ = *p1++; }				// ஢ ᫮.
    while (--n1 != 0);        			//  横 ஢.
  }
  else { *p++ = 1; *p = p1 [n1] >> (BITS-1); }	// ᫮ 0  -1.
}

//	 ᫠   ᫮  ( ).
//	室 ᫮   㫥.

void	cBigNumberMShlD (			//  p1<<=BITS.
			EXPTR(long) p1		//  ࠧ *p1 + 2.
	)
{
  size_t n1 = (size_t)(*p1);			// ᫮ ᫮.
  p1 [0] = n1 + 1;
  do						//  ஢ ᫮.
    { p1 [n1 + 1] = p1 [n1]; }			// ஢ ᫮.
  while (--n1 != 0);   				//  横 ஢.
  p1 [1] = 0;
}

//================================================
//	 樨.
//================================================

//	   ⥬ ⮢ ᨨ  ਡ 1.
//	1) 塞  ᫮   ࢮ 㫥 १.
//	2) 㥬 ᫥騥 ᫮.
//	3) ᫨ ᫥ ᫮ ,  襥 ᫮ ࠢ 100..(⮢),
//	     㫥 ᫮.
//	   ᫨   ᫮ १ ࠢ 11..  100..(⮢),
//	    㤠 襥 ᫮.

size_t	_cBigNumberNeg (			//   p = -p1.
			const EXPTR(long) p1,	// 室 ᫮.
			EXPTR(long) p		//  ࠧ *p1 + 2.
	)					// p1  p  ᮢ.
{
  size_t n1 = (size_t)(*p1++);	 		// ᫮ ᫮.
  p++;
  size_t n = n1;				// 稪 ᫮.
  if (n)
  do						//  ᬥ .
  {
    long lp;					// ⨬ ᫮.
    if ((*p = lp = -*p1) != 0)			//  .
    {                                           // 祭 㫥 ᫮.
      if (--n != 0)				//   ᫮?
      {						// ᫨ ᫮ :
	do					//  ᨨ.
	  { ++p1; ++p; *p = lp = ~*p1; }	// ⮢  ᫮.
	while (--n != 0);      			//  横 ᨨ.
	return (n1 - (lp == (p[-1]>>(BITS-1))));//  襣 ᫮,
      }      					// ᫨  譥.

      if (lp != LONG_MIN) return (n1);		// ᫨  ᫮ , 
      p [1] = 0; return (n1 + 1);		// ஢ઠ ९ 
    }						//  襣 ᫮.
  }
  while ((++p1, ++p, --n) != 0);		//  横 ᬥ .

  return (n1); 					//  ᫮ 㫥.
}
//#define cBigNumberNeg(p1,p)	(size_t)(*(p)=_cBigNumberNeg(p1,p))

//	ਡ 1:
//	1) ਡ  ᫮ 1   ࢮ 㫥 १.
//	2) ᫨ ᫥ ᫮ ,  襥 ᫮ ࠢ 100..(⮢),
//	     㫥 ᫮.
//	   ᫨   ᫮ १ ࠢ 11..  100..(⮢),
//	    㤠 襥 ᫮.

size_t	_cBigNumberMInc (			//  p1 = p1 + 1.
			EXPTR(long) p1		//  ࠧ *p1 + 2.
	)					
{
  size_t n1 = (size_t)(*p1++);	 		// ᫮ ᫮.
  size_t n = n1;				// 稪 ᫮.

  if (n)					//     ᫮.
  {
    do						//  ਡ 1.
    {
      long lp;					// ⨬ ᫮.
      if ((*p1 = lp = *p1 + 1) != 0)		// ਡ 1.
      {						// 祭 㫥 ᫮.
        if (--n != 0)				//   ᫮?
        {
          if (--n != 0) return (n1);		// ᫨ ⠫ 1 ᫮
	  return (n1 - (p1[1]==(lp>>(BITS-1))));//   譥,  㤠.
        }					
	if (lp != LONG_MIN) return (n1);	// ᫨  ᫮ , 
        p1 [1] = 0; return (n1 + 1);		// ஢ઠ ९ 
      }                             		//  襣 ᫮.
    }
    while ((++p1, --n) != 0); 			//  横 ਡ 1.
  }
  else { *p1 = 1; n1 = 1; }			// ଠ ⮣ ᫠.

  return (n1); 					//  ᫮ 㫥.
}
//#define cBigNumberMInc(p1)	(size_t)(*(p1)=_cBigNumberMInc(p1))

//	⠭ 1:
//	1)   ᫮ 1   ࢮ १, ⫨筮  ~0.
//	2) ᫨ ᫥ ᫮ ,  襥 ᫮ ࠢ 011..(⮢),
//	     筮 ᫮.
//	   ᫨   ᫮ १ ࠢ 00..  011..(⮢),
//	    㤠 襥 ᫮.

size_t	_cBigNumberMDec (			// ⠭ p1 = p1 - 1.
			EXPTR(long) p1		//  ࠧ *p1 + 2.
	)					
{
  size_t n1 = (size_t)(*p1++);	 		// ᫮ ᫮.
  size_t n = n1;				// 稪 ᫮.

  if (n)					//     ᫮.
  {
    do						//  ⠭ 1.
    {
      long lp;					// ⨬ ᫮.
      if ((*p1 = lp = *p1 - 1) != ~0)		// ⠭ 1.
      {						// 祭 筮 ᫮.
        if (--n != 0)				//   ᫮?
        {
          if (--n != 0) return (n1);		// ᫨ ⠫ 1 ᫮
          return (n1 - (p1[1]==(lp>>(BITS-1))));//   譥,  㤠.
        }					
        if (lp != LONG_MAX) return (n1);	// ᫨  ᫮ , 
	p1 [1] = ~0; return (n1 + 1);		// ஢ઠ ९ 
      }                             		//  襣 ᫮.
    }
    while ((++p1, --n) != 0); 			//  横 ⠭ 1.
  }
  else { *p1 = -1; n1 = 1; }			// ଠ ⮣ ᫠.

  return (n1); 					//  ᫮ .
}
//#define cBigNumberMDec(p1)	(size_t)(*(p1)=_cBigNumberMDec(p1))

//	  믮 ᫥⥫쭮  ७ᮬ
//	襣 ࠧ鸞  ᫥饥 ᫮.
//	᫨  ᫥ ࠧ鸞 襣 ᫮  ᮢ,
//	    ᫮, 祭 ⥬
//	७ 襣 ࠧ鸞 ᫥ ᫮.

size_t	_cBigNumberMMul2 (			//  p1 <<= 1.
			EXPTR(long) p1		//  ࠧ *p1 + 2.
	)
{
  size_t n1 = (size_t)(*p1++);	 		// ᫮ ᫮.
  long num = 0;					//   ᤢ.
  size_t n = n1;				// 稪 ᫮.

  if (n)
  do                                            //  ᤢ ᫮.
  {
    long pass = (unsigned long)num >> (BITS-1);	//   ।饣 ᫮.
    num = *p1;					// 饥 ᫮  ᤢ.
    *p1++ = (num << 1) | pass;			// 饥 ᫮ ᫥ ᤢ.
  }
  while (--n != 0);				//  横 ᤢ ᫮.

  num >>= (BITS-2);				// ࠡ⪠ ९
  long pass = num >> 1;				//  ᫥ ᫮:
  if (num != pass) { *p1 = pass; ++n1; }	// 塞  ࠧ.

  return (n1);					// 頥 ᫮ ᫮.
}
//#define cBigNumberMMul2(p1)	(size_t)(*(p1)=_cBigNumberMMul2(p1))

//	ਠ ᤢ   ஢.

size_t	_cBigNumberMul2 (			//  p = p1 << 1.
		const	EXPTR(long) p1,		// ࠭.
			EXPTR(long) p		//  ࠧ *p1 + 2.
	)
{
  size_t n1 = (size_t)(*p1++);	 		// ᫮ ᫮.
  p++;
  long num = 0;					//   ᤢ.
  size_t n = n1;				// 稪 ᫮.

  if (n)
  do                                            //  ᤢ ᫮.
  {
    long pass = (unsigned long)num >> (BITS-1);	//   ।饣 ᫮.
    num = *p1++;				// 饥 ᫮  ᤢ.
    *p++ = (num << 1) | pass;			// 饥 ᫮ ᫥ ᤢ.
  }
  while (--n != 0);				//  横 ᤢ ᫮.

  num >>= (BITS-2);				// ࠡ⪠ ९
  long pass = num >> 1;				//  ᫥ ᫮:
  if (num != pass) { *p = pass; ++n1; }		// 塞  ࠧ.

  return (n1);					// 頥 ᫮ ᫮.
}
//#define cBigNumberMul2(p1,p)	(size_t)(*(p)=_cBigNumberMul2(p1,p))

//	 ࠢ 믮 ᫥⥫쭮  ७ᮬ
//	襣 ࠧ鸞  ।饥 ᫮.
//	 襣 ᫮ , ⠫ - .
//	᫨  ᤢ  ࠧ 襣 ᫮ ᮢ,
//	 襥 ᫮ १ 㤠.

size_t	_cBigNumberMDiv2 (			//  p1 <<= 1.
			EXPTR(long) p1		//  ࠧ *p1 + 1.
	)
{
  size_t n1 = (size_t)(*p1);	 		// ᫮ ᫮.
  size_t n = n1;				// 稪 ᫮.
  p1 += n;					// 襥 ᫮.
  if (n)					//  ᫮?
  {
    if (--n != 0)				//   ᫮.
    {
      long num = *p1;				// 襥 ᫮  ᤢ.
      if (num == (*p1-- = (num >> 1)))		//  襣 ᫮.
        --n1;					// , ᫨ 0  ~0.
      do					//  ᤢ ᫮.
      {
        long pass = num << (BITS-1);		//   ᫥饣 ᫮.
	num = *p1;				// 饥 ᫮  ᤢ.
	*p1-- = ((unsigned long)num>>1) | pass;	// 饥 ᫮ ᫥ ᤢ.
      }
      while (--n != 0);				//  横 ᤢ ᫮.
    }
    else           				// 쪮  ᫮.
    {
      (*p1) >>= 1;				// .
    }
  }
  return (n1);					// 뤠 ᫮ ᫮.
}
//#define cBigNumberMDiv2(p1)	(size_t)(*(p1)=_cBigNumberMDiv2(p1))

//	ਠ ᤢ ࠢ  ஢.

size_t	_cBigNumberDiv2 (			//  p = p1 << 1.
		const	EXPTR(long) p1,		// ࠭.
			EXPTR(long) p		//  ࠧ *p1 + 1.
	)
{
  size_t n1 = (size_t)(*p1);	 		// ᫮ ᫮.
  size_t n = n1;				// 稪 ᫮.
  p1 += n;					// 襥 ᫮.
  p  += n;					// 襥 ᫮.
  if (n)					//  ᫮?
  {
    if (--n != 0)				//   ᫮.
    {
      long num = *p1--;				// 襥 ᫮  ᤢ.
      if (num == (*p-- = (num >> 1)))		//  襣 ᫮.
        --n1;					// , ᫨ 0  ~0.
      do					//  ᤢ ᫮.
      {
        long pass = num << (BITS-1);		//   ᫥饣 ᫮.
	num = *p1--;				// 饥 ᫮  ᤢ.
	*p-- = ((unsigned long)num>>1) | pass;	// 饥 ᫮ ᫥ ᤢ.
      }
      while (--n != 0);				//  横 ᤢ ᫮.
    }
    else           				// 쪮  ᫮.
    {
      *p = (*p1) >> 1;				// .
    }
  }
  return (n1);					// 뤠 ᫮ ᫮.
}

//#define cBigNumberDiv2(p1,p)	(size_t)(*(p)=_cBigNumberDiv2(p1,p))

//================================================
//	ଠ.
//================================================

size_t	_cBigNumberFit  (			// ଠ.
			EXPTR(long) p1		//    ᫮.
	)					//     2.
{
  register size_t n = (size_t)(*p1);		// ᫮ ᫮.
  p1 += n;					// ⮢ 㪠⥫.
  register long pass;				// 襥 ᫮.
  register long lp;				// ।饥 ᫮.

  if (n)					// ᫨  襬 ᫮  
  {						// 襬  ।饣
    lp = *p1;					// ᫮  0   1, 
    do continue;				// 㤠 襥 ᫮.
    while (--n != 0 &&
	(pass = lp, lp = p1 [-1], --p1, pass == (lp>>(BITS-1))));
  }						// ᫨   ᫮ ,
  else { p1 [1] = 0; }				//  㫥 ᫮.

  return (n + 1);				// 뤠 ᫮ ᫮.
}
//#define cBigNumberFit(p1)	(size_t)(*(p1)=_cBigNumberFit(p1))

//================================================
//	⮢ ⠡ ᤢ.
//================================================

//	᫮ ଠ,   ⮬   ᫥ ᫠
//	ନ ⠡ ᤢ  1..BITS-1  蠣 *p + 2.
//	᫥ ⮣ ᫮  ⢮  ⨬஢
//	, ᯮ ⠡ ᤢ.
//	㭪 ᥣ 뤠 ଠ ᫮ 
//	ଠ ᤢ.

void	cBigNumberTab  (			// ⮢ ⠡ ᤢ.
			EXPTR(long) p		// ᫮   ࠧ
	)					// (*p + 3) * BITS.
						//   ᤢ
{						// p<<1..BITS-1  蠣 *p + 2.
  size_t n = cBigNumberFit (p) + 2;		//   .
  EXPTR(long) pp = p;				// 稩 㪠⥫.
  int ns = BITS - 1;				// 稪 ⮢ ᤢ.

  do						// .
  {
    pp += n;
    cBigNumberMul2 (p, pp);			//  ⥫  .
    p = pp;
  }
  while (--ns > 0);				//  横  ᫮.
}

//================================================
//	᪨ 㭪樨.
//================================================

//	 믮 樨  ࠧ  ᥫ
//	 ⠪, ⮡  ᫠ ᮤঠ max(n1,n2)
//	᫮. 祭 ᫮ ࠡ뢠 ᫮.
//	 㪮稢   ,  襥
//	᫮  㤥 ⫨  १ ७
//	襣 ࠧ鸞 ।᫥ ᫮.
//
//	ᮡ ॠ樨:
//	- ।,  ன ࠭   ࢮ.
//	- 㭪樨 ᥣ 뤠 ଠ ᫮.

size_t	_cBigNumberXor  (			//  mod 2 p = p1 ^ p2
		const	EXPTR(long) p1,		// ࠭.
		const	EXPTR(long) p2,		// ࠭ (  p1).
			EXPTR(long) p		//  ࠧ *p1 + 1.
	)					// p1  p2  p  ᮢ.
{
  size_t n1 = (size_t)(*p1++);	 		// ᫮ ᫮.
  size_t n2 = (size_t)(*p2++);	 		// ᫮ ᫮.
  p++;
  assert (n1 >= n2);

  {
    register long lp2 = 0;			// 饥 ᫮ p2;

//	ࠡ⪠ ᫮ p1  p2.
   
    {
      size_t n;					// 稪 ᫮.
      if ((n = n2) != 0)
      {
	do { *p++ = *p1++ ^ (lp2 = *p2++); }	//   p1  p2.
	while (--n != 0);			//  横  p1  p2.
      }
    }

//	४ ⪠ p1, ᫨ p1  p2.

    {
      lp2 >>= (BITS-1);				//  ࠧ p2.
      size_t n;					// 稪 ᫮.
      if ((n = n1 - n2) != 0)
      {
	do { *p++ = *p1++ ^ lp2; }		//   p1.
        while (--n != 0);			//  横  p1.
      }
    }
    --p;  					// ⮢ 㪠⥫.
  }

//	ଠ - 㤠 譨  ᫮ p,   0  1
//	 ᮢ  ७  ࠧ鸞 ।饣 ᫮.

  {
    register long pass;				// 襥 ᫮.
    register long lp;				// ।饥 ᫮.
    register size_t n = n1;			// ᫮ ᫮.
    if (n)					// ᫨  襬 ᫮  
    {                                           // 襬  ।饣 
      lp = *p;					// ᫮  0   1, 
      do --p;      				// 㤠 襥 ᫮.
      while
	(--n != 0 && (pass = lp, lp = *p, pass == (lp>>(BITS-1))));
    }                                           // ᫨   ᫮ ,
    else { p [1] = 0; }				//  㫥 ᫮.

    return (n + 1);				// 뤠 ᫮ ᫮ p.
  }
}
//#define cBigNumberXor(p1,p2,p) (size_t)(*(p)=_cBigNumberXor(p1,p2,p))

//

size_t	_cBigNumberAnd  (			//  p = p1 & p2
		const	EXPTR(long) p1,		// ࠭.
		const	EXPTR(long) p2,		// ࠭ (  p1).
			EXPTR(long) p		//  ࠧ *p1 + 1.
	)					// p1  p2  p  ᮢ.
{
  size_t n1 = (size_t)(*p1++);	 		// ᫮ ᫮.
  size_t n2 = (size_t)(*p2++);	 		// ᫮ ᫮.
  p++;
  assert (n1 >= n2);

  {
    register long lp2 = 0;			// 饥 ᫮ p2;

//	ࠡ⪠ ᫮ p1  p2.

    {
      size_t n;					// 稪 ᫮.
      if ((n = n2) != 0)
      {
	do { *p++ = *p1++ & (lp2 = *p2++); }	//   p1  p2.
	while (--n != 0);			//  横  p1  p2.
      }
    }

//	४ ⪠ p1, ᫨ p1  p2.

    {
      lp2 >>= (BITS-1);				//  ࠧ p2.
      size_t n;					// 稪 ᫮.
      if ((n = n1 - n2) != 0)
      {
	do { *p++ = *p1++ & lp2; }		//   p1.
        while (--n != 0);			//  横  p1.
      }
    }
    --p;  					// ⮢ 㪠⥫.
  }

//	ଠ - 㤠 譨  ᫮ p,   0  1
//	 ᮢ  ७  ࠧ鸞 ।饣 ᫮.

  {
    register long pass;				// 襥 ᫮.
    register long lp;				// ।饥 ᫮.
    register size_t n = n1;			// ᫮ ᫮.
    if (n)					// ᫨  襬 ᫮   
    {                                           // 襬  ।饣
      lp = *p;					// ᫮  0   1, 
      do continue;				// 㤠 襥 ᫮.
      while (--n != 0 &&
	(pass = lp, lp = p [-1], --p, pass == (lp>>(BITS-1))));
    }                                           // ᫨   ᫮ ,
    else { p [1] = 0; }				//  㫥 ᫮.

    return (n + 1);				// 뤠 ᫮ ᫮ p.
  }
}
//#define cBigNumberAnd(p1,p2,p) (size_t)(*(p)=_cBigNumberAnd(p1,p2,p))

//

size_t	_cBigNumberOr  (			//  p = p1 & p2
		const	EXPTR(long) p1,		// ࠭.
		const	EXPTR(long) p2,		// ࠭ (  p1).
			EXPTR(long) p		//  ࠧ *p1 + 1.
	)					// p1  p2  p  ᮢ.
{
  size_t n1 = (size_t)(*p1++);	 		// ᫮ ᫮.
  size_t n2 = (size_t)(*p2++);	 		// ᫮ ᫮.
  p++;
  assert (n1 >= n2);

  {
    register long lp2 = 0;			// 饥 ᫮ p2;

//	ࠡ⪠ ᫮ p1  p2.

    {
      size_t n;					// 稪 ᫮.
      if ((n = n2) != 0)
      {
        do { *p++ = *p1++ | (lp2 = *p2++); }	//   p1  p2.
	while (--n != 0);			//  横  p1  p2.
      }
    }

//	४ ⪠ p1, ᫨ p1  p2.
  
    {
      lp2 >>= (BITS-1);				//  ࠧ p2.
      size_t n;					// 稪 ᫮.
      if ((n = n1 - n2) != 0)
      {
        do { *p++ = *p1++ | lp2; }		//   p1.
        while (--n != 0);			//  横  p1.
      }
    }
    --p;  					// ⮢ 㪠⥫.
  }

//	ଠ - 㤠 譨  ᫮ p,   0  1
//	 ᮢ  ७  ࠧ鸞 ।饣 ᫮.

  {
    register long pass;				// 襥 ᫮.
    register long lp;				// ।饥 ᫮.
    register size_t n = n1;			// ᫮ ᫮.
    if (n)					// ᫨  襬 ᫮   
    {                                           // 襬  ।饣 
      lp = *p;					// ᫮  0   1, 
      do continue;				// 㤠 襥 ᫮.
      while (--n != 0 && 
	(pass = lp, lp = p [-1], --p, pass == (lp>>(BITS-1))));
    }                                           // ᫨   ᫮ ,
    else { p [1] = 0; }				//  㫥 ᫮.

    return (n + 1);				// 뤠 ᫮ ᫮ p.
  }
}
//#define cBigNumberOr(p1,p2,p)  (size_t)(*(p)=_cBigNumberOr(p1,p2,p))

//================================================
//	㭪樨 ᫮  ⠭.
//================================================

//	 ᫮  ᥫ  ࠧ  ᥫ
//	 ⠪, ⮡  ᫠ ᮤঠ max(n1,n2)+1
//	᫮. 祭 ᫮ ᪫뢠 ᫮  ࠡ⪮
//	७ᮢ   ᫮  㣮. 祭 ⠪
//	ࠧ ᫮ 㪮稢   ,  襥
//	᫮  㤥 ⫨  १ ७
//	襣 ࠧ鸞 ।᫥ ᫮.
//
//	ᮡ ॠ樨:
//	- ।,  ன ࠭   ࢮ.
//	- 㭪 ᥣ 뤠 ଠ ᫮.

size_t	_cBigNumberAdd  (			//  p = p1 + p2
		const	EXPTR(long) p1,		// .
		const	EXPTR(long) p2,		//  (  p1).
			EXPTR(long) p		//  ࠧ *p1 + 2.
	)					// p1  p2  p  ᮢ.
{
  size_t n1 = (size_t)(*p1++);	 		// ᫮ ᫮.
  size_t n2 = (size_t)(*p2++);	 		// ᫮ ᫮.
  p++;
  assert (n1 >= n2);

  register unsigned long pass = 0;		// ७  ᫥饥 ᫮ p.
	// ७ ᯮ  襬  pass
	// unsigned long ᯥ稢 ᤢ pass >>  ७ .
  {
    register long lp1 = 0;			// 饥 ᫮ p1;
    register long lp2 = 0;			// 饥 ᫮ p2;

//	㬬஢ ᫮ p1  p2.
   
    {
      size_t n;					// 稪 ᫮.
      if ((n = n2) != 0)
      {
	do					//   p1  p2.
        {
	  lp1 = *p1++; lp2 = *p2++;
	  pass = (~(*p++ = (pass>>(BITS-1)) + lp1 + lp2) & (lp1 | lp2))
							 | (lp1 & lp2);
        }
	while (--n != 0);			//  横  p1  p2.
      }
    }

//	४ ⪠ p1, ᫨ p1  p2.
  
    {
      size_t n;					// 稪 ᫮.
      if ((n = n1 - n2) != 0)
      {
	register const long *pp = p1;		// ⨬.
	if ((lp2 & LONG_MIN) == 0)
	{
          do					//   p1.
          {    
	    lp1 = *pp++;
            pass = ~(*p++ = (pass>>(BITS-1)) + lp1) & lp1;
	  }
	  while (--n != 0);			//  横  p1.
	}
	else
	{
	  do					//   p1.
          {
	    lp1 = *pp++;
            pass = ~(*p++ = (pass>>(BITS-1)) + lp1 - 1) | lp1;
          }
	  while (--n != 0);			//  横  p1.
	}
      }
    }
    --p;  					// ⮢ 㪠⥫.

//	㬬஢ ७  ࠧ冷 p1  p2.
//	祭 ⠪ ࠧ 襥 ᫮ p ⮨ ⮫쪮  0  1.
//	襥 ᫮ p   pass.
    pass = (pass>>(BITS-1)) + ((lp1)>>(BITS-1)) + ((lp2)>>(BITS-1));
  }

//	ଠ - 㤠 譨  ᫮ p,   0  1
//	 ᮢ  ७  ࠧ鸞 ।饣 ᫮.

  {
    register long lp = *p;			// ।饥 ᫮.
    register size_t n = n1;			// ᫮ ᫮, ஬ 襣.
    if (n && (long)pass == (lp>>(BITS-1)))	// ᫨  襬 ᫮  
    {						// 襬  ।饣
      do continue;				// ᫮  0   1, 
      while (--n != 0 &&                        // 㤠 襥 ᫮. 
	(pass = lp, lp = p [-1], --p, (long)pass == (lp>>(BITS-1))));
    }
    else { p [1] = pass; }			//  襣 ᫮..

    return (n + 1);				// 뤠 ᫮ ᫮ p.
  }
}
//#define cBigNumberAdd(p1,p2,p) (size_t)(*(p)=_cBigNumberAdd(p1,p2,p))

//	 ⠭  ᥫ  ࠧ  ᥫ
//	 ⠪, ⮡  ᫠ ᮤঠ max(n1,n2)+1
//	᫮. 祭 ᫮  ᫮  ࠡ⪮
//	   ᫮  㣮. 祭 ⠪
//	ࠧ ᫮ 㪮稢   ,  襥
//	᫮  㤥 ⫨  १ ७
//	襣 ࠧ鸞 ।᫥ ᫮.
//
//	ᮡ ॠ樨:
//	- ।,  ன ࠭   ࢮ.
//	-  ⠭ ॠ   ਠ:
//	  ⠭  ⠭  ᬥ .
//	- 㭪樨 ᥣ 뤠 ଠ ᫮.

size_t	_cBigNumberSub  (			// ⠭ p = p1 - p2
		const	EXPTR(long) p1,		// ⠥.
		const	EXPTR(long) p2,		// ⥫ (  p1).
			EXPTR(long) p		//  ࠧ *p1 + 2.
	)                                       // p1, p2  p  ᮢ.
{
  size_t n1 = (size_t)(*p1++);	 		// ᫮ ᫮.
  size_t n2 = (size_t)(*p2++);	 		// ᫮ ᫮.
  p++;
  assert (n1 >= n2);

  register unsigned long pass = ~0UL;	// ७  ᫥饥 ᫮ p.
	// ७ ᯮ  襬  pass
	// unsigned long ᯥ稢 ᤢ pass >>  ७ .
	// 砫쭮 祭 ᯥ稢 ਡ .
  {
    register long lp1 = 0;			// 饥 ᫮ p1;
    register long lp2 = ~0;			// 饥 ᫮ ~p2;

//	㬬஢ ᫮ p1  ~p2.

    {
      size_t n;					// 稪 ᫮.
      if ((n = n2) != 0)
      {
        do					//   p1  p2.
	{
	  lp1 = *p1++; lp2 = ~(*p2++);
	  pass = (~(*p++ = (pass>>(BITS-1)) + lp1 + lp2) & (lp1 | lp2))
							 | (lp1 & lp2);
	}
	while (--n != 0);			//  横  p1  p2.
      }
    }

//	४ ⪠ p1, ᫨ p1  p2.

    {
      size_t n;					// 稪 ᫮.
      if ((n = n1 - n2) != 0)
      {
        register const long *pp = p1;		// ⨬.
	if ((lp2 & LONG_MIN) == 0)
	{
	  do					//   p1.
          {    
	    lp1 = *pp++;
            pass = ~(*p++ = (pass>>(BITS-1)) + lp1) & lp1;
          }
          while (--n != 0);			//  横  p1.
	}
	else
	{
	  do					//   p1.
	  {
            lp1 = *pp++;
	    pass = ~(*p++ = (pass>>(BITS-1)) + lp1 - 1) | lp1;
	  }
	  while (--n != 0);			//  横  p1.
        }
      }
    }
    --p;  					// ⮢ 㪠⥫.

//	㬬஢ ७  ࠧ冷 p1  p2~.
//	祭 ⠪ ࠧ 襥 ᫮ p ⮨ ⮫쪮  0  1.
//	襥 ᫮ p   pass.
    pass = (pass>>(BITS-1)) + ((lp1)>>(BITS-1)) + ((lp2)>>(BITS-1));
  }

//	ଠ - 㤠 譨  ᫮ p,   0  1
//	 ᮢ  ७  ࠧ鸞 ।饣 ᫮.

  {
    register long lp = *p;			// ।饥 ᫮.
    register size_t n = n1;			// ᫮ ᫮, ஬ 襣.
    if (n && (long)pass == (lp>>(BITS-1)))	// ᫨  襬 ᫮  
    {						// 襬  ।饣
      do continue;				// ᫮  0   1, 
      while (--n != 0 &&                        // 㤠 襥 ᫮. 
	(pass = lp, lp = p [-1], --p, (long)pass == (lp>>(BITS-1))));
    }
    else { p [1] = pass; }			//  襣 ᫮..

    return (n + 1);				// 뤠 ᫮ ᫮ p.
  }
}
//#define cBigNumberSub(p1,p2,p) (size_t)(*(p)=_cBigNumberSub(p1,p2,p))

//	⠭  ᬥ .

size_t	_cBigNumberSubS (			// ⠭ p = p2 - p1
		const	EXPTR(long) p1,		// ⥫.
		const	EXPTR(long) p2,		// ⠥ (  p1).
			EXPTR(long) p		//  ࠧ *p1 + 2.
	)                                       // p1, p2  p  ᮢ.
{
  size_t n1 = (size_t)(*p1++);	 		// ᫮ ᫮.
  size_t n2 = (size_t)(*p2++);	 		// ᫮ ᫮.
  p++;
  assert (n1 >= n2);

  register unsigned long pass = ~0UL;		// ७  ᫥饥 ᫮ p.
	// ७ ᯮ  襬  pass
	// unsigned long ᯥ稢 ᤢ pass >>  ७ .
	// 砫쭮 祭 ᯥ稢 ਡ .
  {
    register long lp1 = ~0;			// 饥 ᫮ ~p1;
    register long lp2 = 0;			// 饥 ᫮ p2;

//	㬬஢ ᫮ ~p1  p2.

    {
      size_t n;					// 稪 ᫮.
      if ((n = n2) != 0)
      {
	do					//   p1  p2.
        {
	  lp1 = ~(*p1++); lp2 = *p2++;
	  pass = (~(*p++ = (pass>>(BITS-1)) + lp1 + lp2) & (lp1 | lp2))
							 | (lp1 & lp2);
	}
	while (--n != 0);			//  横  p1  p2.
      }
    }

//	४ ⪠ p1, ᫨ p1  p2.
  
    {
      size_t n;					// 稪 ᫮.
      if ((n = n1 - n2) != 0)
      {
	register const long *pp = p1;		// ⨬.
	if ((lp2 & LONG_MIN) == 0)
	{
	  do					//   p1.
	  {
	    lp1 = ~(*pp++);
	    pass = ~(*p++ = (pass>>(BITS-1)) + lp1) & lp1;
	  }
	  while (--n != 0);			//  横  p1.
	}
        else
	{
          do					//   p1.
	  {
	    lp1 = ~(*pp++);
	    pass = ~(*p++ = (pass>>(BITS-1)) + lp1 - 1) | lp1;
          }
          while (--n != 0);			//  横  p1.
	}
      }
    }
    --p;  					// ⮢ 㪠⥫.

//	㬬஢ ७  ࠧ冷 ~p1  p2.
//	祭 ⠪ ࠧ 襥 ᫮ p ⮨ ⮫쪮  0  1.
//	襥 ᫮ p   pass.
    pass = (pass>>(BITS-1)) + ((lp1)>>(BITS-1)) + ((lp2)>>(BITS-1));
  }

//	ଠ - 㤠 譨  ᫮ p,   0  1
//	 ᮢ  ७  ࠧ鸞 ।饣 ᫮.

  {
    register long lp = *p;			// ।饥 ᫮.
    register size_t n = n1;			// ᫮ ᫮, ஬ 襣.    
    if (n && (long)pass == (lp>>(BITS-1)))	// ᫨  襬 ᫮  
    {						// 襬  ।饣
      do continue;				// ᫮  0   1, 
      while (--n != 0 &&                        // 㤠 襥 ᫮.
	(pass = lp, lp = p [-1], --p, (long)pass == (lp>>(BITS-1))));
    }
    else { p [1] = pass; }			//  襣 ᫮..

    return (n + 1);				// 뤠 ᫮ ᫮ p.
  }
}
//#define cBigNumberSubS(p1,p2,p) (size_t)(*(p)=_cBigNumberSubS(p1,p2,p))

//	⠭  ᤢ ண ᫠  㪠 ᫮ ᫮.
//	ਬ  .
//	 楫 ⨬樨 ।, :
//	- ᫠   .
//	- ஥ ᫮   ࢮ  ⭮ 祭.
//	- ᫥ ⠭ ᫮    ᫥ 㬥蠥.
//	-  ண ᫠  0.
//	-  ࢮ ᫠  , 祬 ࠧ ண ᫠
//	  ᫥ ᤢ.
//	 믮  ᫮ 㭪 뤠 ଠ ᫮.

//	। ⠭ 뢠 㭪 cBigNumberMSubD_skip0()
//	  ᫠ 㫥  砫 ⥫.

static	size_t	_cBigNumberMSubD_skip;		// ᫮ 0-᫮  砫
						// ⥫ + 1.

void	cBigNumberMSubD_skip0 (			// ᫥ ᫠ 0-᫮.
		const	EXPTR(long) p2		// ⥫.
)
{
  size_t n2 = (size_t)(*p2++);			// ᫮ ᫮ p2.
  _cBigNumberMSubD_skip = 1;			// ᫮ 0-᫮ p2 + 1.
  if (n2)
  {
    while (--n2 > 0)
    {
      if (*p2++ != 0) break;			// 諨 㫥 ᫮.
      ++_cBigNumberMSubD_skip;			// ᫮ 0-᫮ p2 + 1.
    }
  }
}

#ifndef	_CBIGNUM_ASM				// ᫨  ।.

size_t	_cBigNumberMSubD (			// ⠭ p1 -= p2<<k2*BITS
			EXPTR(long) p1,		// ⠥.
		const	EXPTR(long) p2,		// ⥫ ࠧ  n1-k2.
			size_t k2		//  ⥫ .
	)					// p1  p2  ᮢ.
{
  size_t n2 = (size_t)(*p2);			// ᫮ ᫮ p2.
  assert ((size_t)(*p1) >= n2 + k2);		// ஢ઠ ࠧ.
  assert (n2 > 0);				// ஢ઠ ࠧ.

//	 横 c ࠦ:
//	pass = (((*p1 = pass + lp1 - lp2) | (lp1 ^ lp2)) &  (~lp1 | lp2))
//		>> (BITS-1);
//	ࠦ ᯨᠭ   ᫥⥫쭮 ᢠ:
//	*p1 = pass = = pass + lp1 - lp2;
//	pass |= (lp1 ^= lp2))	// ⭠  ^  ^=
//	pass &= (~lp1 | lp2))	// ᢮  ॣ.
//	pass >>= (BITS-1)
//	ᢠ ࠧ ஢ઠ ᫮ 横  饭ﬨ
//	㪠⥫  ⨬樨 㧪 ஢ Pentium.

  register long pass = 0;			// : 0  -1.
  {
    p1 += (k2 + _cBigNumberMSubD_skip);		// 砫 ⠭  p1.
    const EXPTR(long) pp = p2 + n2;		// ᫥ ᫮ p2.
    p2 += _cBigNumberMSubD_skip;		// 砫 ⠭ p2.

    for (;;)					//   p1  p2.
    {
      register long lp1;			// 饥 ᫮ p1;
      register long lp2;			// 饥 ᫮ ~p2;

      lp1 = *p1;	lp2 = *p2;		// 騥 ᫮ p1  p2;
      pass += lp1;	lp1 ^= lp2;
      pass -= lp2;	*p1 = pass;
      if (p2 == pp) break;
      pass |= lp1;	lp1 = ~lp1;
      ++p1;		lp2 |= lp1;
      pass &= lp2;	++p2;
      pass >>= (BITS-1);
    }
  }

//	ଠ - 㤠 譨  ᫮ p,   0  1
//	 ᮢ  ७  ࠧ鸞 ।饣 ᫮.
//	।-᫮:  pass 室 ᫥ 祭 ᫮,
//	p1 㪠뢠  ᫥ 祭 ᫮.

  {
    register size_t n1 = n2 + k2;

//	 横 믮 樨:
//	do continue;
//	while (--n1 != 0 &&
//		lp1==(lp1 = pass, pass = p1[-2], --p1, pass>>(BITS-1)));

    for (;;)
    {
      register long lp1;			// 襥 ᫮.
      register long lp2;			// ।饥 ᫮.
      if (--n1 == 0)	break;			// ⠫  ᫮.
      lp2 = p1[-1];	--p1;
      lp1 = pass;	pass = lp2;
      lp2 >>= BITS-1;
      if (lp1 != lp2)	break;
    }
    return (n1 + 1);				// 뤠 ᫮ ᫮ p.
  }
}
//#define cBigNumberMSubD(p1,p2,k2) (size_t)(*(p1)=_cBigNumberMSubD(p1,p2,k2))

#endif//_CBIGNUM_ASM	

//================================================
//	稥 .
//================================================

static exarray<long> cBigBuf1;	// .
static exarray<long> cBigBuf2;	// , , ⮪.
static exarray<long> cBigBuf3;	// ⥯  .

//================================================
//	㭪樨 㬭.
//================================================

//	㭪 㬭 ॠ  ᭮
//	誮쭮 ⬠, ⨬쭮 
//	㬭  ᫠  ⪮,  ⠪
//	 㬭  ᫥  100 .
//	㭪 ᥣ 뤠 ଠ ᫮.
//	   ५   ᮬ + 1.

void	cBigNumberMul (				//  p = p1 * p2.
		const	EXPTR(long) p1,		// .
		const	EXPTR(long) p2,		// ⥫ (  p1).
			EXPTR(long) p		//  ࠧ *p1 + *p2 + 2.
	)                                       // p1  p2  p  ᮢ.
{
  size_t n1 = (size_t)(*p1);			// ᫮ ᫮.
  size_t n2 = (size_t)(*p2);	 		// ᫮ ᫮.
  assert (n1 >= n2);

  cBigBuf1.checkexpand (n1 + n2 + 1);		// । ,
  cBigBuf2.checkexpand (n2 + 1);		// । ,
  EXPTR(long) pp1 = EXPTRTYPE(cBigBuf1);		//   .
  EXPTR(long) pp2 = EXPTRTYPE(cBigBuf2);		//   ⥫.

  if (p2 [n2] >= 0)				// ⥫ ⥫:
  {						// ஢.
    cBigNumberCopy (p1, pp1);
    cBigNumberCopy (p2, pp2);
  }
  else						// ⥫ ⥫:
  {						// ᬥ .
    cBigNumberNeg (p1, pp1);
    cBigNumberNeg (p2, pp2);
  }

  p [0] = 1; p [1] = 0;				// 㫥 ந.

  if (n2)					// ⥫  ࠢ 0.
  {
    p2 = pp2 + 1;				// 饥 ᫮ ⥫.
    for (;; cBigNumberMMul2 (pp1))		//   ᫮ p2.
    {
      long num = *p2++;				// । ᫮ p2.
      long mask = 1;				// ᪠  ⮢ num.
      if (--n2 == 0)				// 頥 ᫮ 室
      {             				//  ᫥ 横.
	do                                      // 訩  num ᥣ 0.
	  mask <<= 1;			        //  mask  num, 
	while ((num <<= 1) > 0);		// 訩  num ࠢ 0.
	if (mask == 0) break;			// 襥 ᫮ p2 㫥.
      }
      for (;; cBigNumberMMul2 (pp1))		//   ⠬ ᫮ p2.
      {
	if (num & mask) cBigNumberAdd (pp1, p, p);
	if ((mask <<= 1) == 0) break;		//  稫.
      }         				//  横  ⠬ p2.
      if (n2 == 0) break;			//  稫.
    }         					//  横  ᫮ p2.
  }
}

//	㭪 㬭   १ ⫨砥
//	 㭪樨 㬭 ⥬,    믮
//	㫥 室 .

void	cBigNumberMAddMul (			//  p += p1 * p2.
		const	EXPTR(long) p1,		// .
		const	EXPTR(long) p2,		// ⥫ (  p1).
			EXPTR(long) p		//    ࠧ
						// max (*p1 + *p2 + 2, *p + 2).
	)                                       // p1  p2  p  ᮢ.
{
  size_t n1 = (size_t)(*p1);			// ᫮ ᫮.
  size_t n2 = (size_t)(*p2);	 		// ᫮ ᫮.
  assert (n1 >= n2);

  cBigBuf1.checkexpand (n1 + n2 + 1);		// । ,
  cBigBuf2.checkexpand (n2 + 1);		// । ,
  EXPTR(long) pp1 = EXPTRTYPE(cBigBuf1);		//   .
  EXPTR(long) pp2 = EXPTRTYPE(cBigBuf2);		//   ⥫.

  if (p2 [n2] >= 0)				// ⥫ ⥫:
  {						// ஢.
    cBigNumberCopy (p1, pp1);
    cBigNumberCopy (p2, pp2);
  }
  else						// ⥫ ⥫:
  {						// ᬥ .
    cBigNumberNeg (p1, pp1);
    cBigNumberNeg (p2, pp2);
  }

  if (n2)					// ⥫  ࠢ 0.
  {
    p2 = pp2 + 1;				// 饥 ᫮ ⥫.
    for (;; cBigNumberMMul2 (pp1))		//   ᫮ p2.
    {
      long num = *p2++;				// । ᫮ p2.
      long mask = 1;				// ᪠  ⮢ num.
      if (--n2 == 0)				// 頥 ᫮ 室
      {             				//  ᫥ 横.
	do                                      // 訩  num ᥣ 0.
	  mask <<= 1;			        //  mask  num, 
	while ((num <<= 1) > 0);		// 訩  num ࠢ 0.
	if (mask == 0) break;			// 襥 ᫮ p2 㫥.
      }
      for (;; cBigNumberMMul2 (pp1))		//   ⠬ ᫮ p2.
      {
	if (num & mask)
	{
	  if (*pp1 > *p) cBigNumberAdd (pp1, p, p);
          else           cBigNumberAdd (p, pp1, p);
	}
	if ((mask <<= 1) == 0) break;		//  稫.
      }         				//  横  ⠬ p2.
      if (n2 == 0) break;			//  稫.
    }         					//  横  ᫮ p2.
  }
}

//================================================
//	㭪樨 .
//================================================

//	㭪, ࠡ뢠   0.

size_t	cBigNumberMaskDiv0;			// ᪠   0:
						//  0 - 訡 Divide Error
void	cBigNumberDiv0 (void)			// >0 - ஢
{
  cBigNumberMaskDiv0 /= cBigNumberMaskDiv0;
}

//	㭪  । ⭮   ⮪
//	  .  ⪠ ᮢ   .
//	 ⭮ -  ந    ⥫.
//	㭪 ᥣ 뤠 ଠ ⭮  ⮪.
//
//	㭪 cBigNumberDivTab ।,    ⥫
//	ଠ    ,    ⥫
//	室 ⠡ ᤢ, 祭 㭪樥 cBigNumberTab.
//
//      㭪 cBigNumberDiv ࠡ⠥  ᫠  
//	  ॡ  ⠡ ᤢ.
//	᫨  ᪮ ,  㭪 ந ⠡ ᤢ,
//	 ਬ ,  ᯮ騩 ⠡ ᤢ.

void	cBigNumberDivTab (			//  p = p1/p2, p1 %= p2
			EXPTR(long) p1,		// , ⮬ - ⮪.
		const	EXPTR(long) p2,		// ⥫  ⠡ ᤢ.
			EXPTR(long) p		//  ࠧ *p1 + 2.
	)                                       // p1,p2,p   ᮢ.
{
  assert (p1 != p);
  assert (p2 != p);
  assert (p1 != p2);
  assert (cBigNumberIsFit (p1));		// ଠ.
  assert (cBigNumberIsFit (p2));		// ଠ.

  size_t n1 = (size_t)(*p1);			// ᫮ ᫮.
  size_t n2 = (size_t)(*p2);	 		// ᫮ ᫮.
  size_t n = ((n1 > n2)? n1 - n2: 0) + 1;	// ᫮ ᫮  ⭮.

  assert ((p1 [n1] ^ p2 [n2]) >= 0);		//  .

//	⢥ .

  cBigNumberMSubD_skip0 (p2);			// ᫮ 0-᫮ p2.
  *p = n; p += n;				// 稭  p.
  n2 += 2;					//  ⠡ ᤢ.
  if (cBigNumberNot0 (p2))			// ஢ઠ   0.
  {
    long lt = (p1 [n1] < 0) * 2 - 1;		// ⠭  ࠢ
						// ᮫ 祭 ᥫ
						// (p1 >= 0)? -1: 1
    const EXPTR(long) pp2 = p2;			// 稩 㪠⥫.
    do	 					//   ᫮ ⭮.
    {
      --n;					// 稪 ᫮ ⭮.
      pp2 += n2 * BITS;				//  ⥫  ᫮.
      unsigned long mask = (1L << (BITS-1));	// 砫쭠 ᪠.
      *p = 0; 					// 㫥 ᫮ ⭮.
      do					//   ⠬ ⭮.
      {
	pp2 -= n2;				// 騩 ᤢ.
	assert (*pp2 >= (long)(n2 - 2) && *pp2 <  (long) n2);
						//  ⠡ ᤢ?
	int diff = n - (size_t)(*p1)		//  ࠧ஢.
		     + (size_t)(*pp2);
	if (diff <= 0 && (diff < 0 ||		// ᫨ ⮪  
	    cBigNumberCompHigh (p1, pp2) != lt))// ᤢ⮣ ⥫,
	{					//  ஢
	  cBigNumberMSubD (p1, pp2, n);		// ⠭ ⥫ 
	  (*p) += mask;				// ⠭  ⭮.
	}
      }
      while ((mask >>= 1) != 0);		//  横  ⠬.
      --p;					//  ⭮ ନ஢.
    }
    while (n);					//  横  ᫮.
    assert (cBigNumberComp (p1, pp2) == lt);	// ⮪  ⥫?
  }
  else						//   0.
  {						// ᫨   0
    cBigNumberDiv0(); *p-- = 0;			// ࠧ襭,  ⮪
  }						// 㤥 ࠢ .
  cBigNumberFit (p);				// ଠ ⭮.
}

//

void	cBigNumberDiv (				//  p = p1/p2, p1 %= p2
			EXPTR(long) p1,		// , ⮬ - ⮪.
		const	EXPTR(long) p2,		// ⥫.
			EXPTR(long) p		//  ࠧ *p1 + 2.
	)                                       // p2  ᮢ  p1  p.
{
  assert (p1 != p);

//	⮢   ⥫: ஢ ଠ
//	 ᯥ稢 ᮢ .

  size_t n1 = (size_t) cBigNumberFit (p1);	// ᫮ ᫮.
  size_t n2 = (size_t)(*p2);	 		// ᫮ ᫮.
  long signdiv;					//  㫥 ⭮.

  cBigBuf2.checkexpand (exmul (BITS, n2 + 3));	// । ,

  EXPTR(long) pp2 = EXPTRTYPE(cBigBuf2);		//   ⥫.

  if ((p1 [n1] ^ p2 [n2]) >= 0)			//  ᮢ:
    { cBigNumberCopy (p2, pp2); signdiv = 1; }	// ஢ ⥫.
  else						//   ᮢ:
    { cBigNumberNeg (p2, pp2); signdiv = -1; }	// ᬥ  ⥫.

  if (n1 > n2 + 1)				// ⨬஢ ਠ
  {						//  ⠡楩 ᤢ.
    cBigNumberTab (pp2);			// ⮢ ⠡ ᤢ.
    cBigNumberDivTab (p1, pp2, p);		// .
    if (signdiv < 0) cBigNumberNeg (p, p);	//  .
    return;
  }

  n2 = cBigNumberFit (pp2);			// ଠ ⥫.

//	⢥ .

  cBigNumberMSubD_skip0 (p2);			// ᫮ 0-᫮ p2.
  size_t n = ((n1 > n2)? n1 - n2: 0) + 1;	// ᫮ ᫮  ⭮
						// ( 業).
  *p = n; p += n;				// 稭  p.
  if (cBigNumberNot0 (pp2))			// ஢ઠ   0.
  {
    long lt = (p1 [n1] < 0) * 2 - 1;		// ⠭  ࠢ
						// ᮫ 祭 ᥫ
						// (p1 >= 0)? -1: 1
    do	 					//   ᫮ ⭮.
    {
      --n;					// 稪 ᫮ ⭮.
      *p = 0; 					// 㫥 ᫮ ⭮.
      cBigNumberMShlD (pp2);			//  ⥫  ᫮.
      int ns = BITS - 1;			// 稪 ⮢ ᤢ.
      do					//   ⠬ ⭮.
      {
	int diff = cBigNumberMDiv2 (pp2) + n -	//  ⥫  .
		   (size_t)(*p1);		//  ࠧ஢.
	if (diff <= 0 && (diff < 0 ||		// ᫨ ⮪  
	    cBigNumberCompHigh (p1, pp2) != lt))// ᤢ⮣ ⥫,
	{					//  ஢
	  cBigNumberMSubD (p1, pp2, n);		// ⠭ ⥫ 
	  (*p) += (signdiv << ns);		// ⠭  ⭮.
	}
      }
      while (--ns >= 0);			//  横  ⠬.
      --p;					//  ⭮ ନ஢.
    }
    while (n);					//  横  ᫮.
    assert (cBigNumberComp (p1, pp2) == lt);	// ⮪  ⥫?
  }
  else						//   0.
  {						// ᫨   0
    cBigNumberDiv0(); *p-- = 0;			// ࠧ襭,  ⮪
  }						// 㤥 ࠢ .
  cBigNumberFit (p);				// ଠ ⭮.
}

//	㭪 ᫥ ⪠ 
//	᮪饭 ਠ⮬ 㭪樨 ,
//	 ன ᪫祭 ᫥ ⭮.
//	㭪 ᥣ 뤠 ଠ ᫮.
//
//	㭪 cBigNumberMModTab ।,    ⥫
//	ଠ    ,    ⥫
//	室 ⠡ ᤢ, 祭 㭪樥 cBigNumberTab.
//
//      㭪 cBigNumberMMod ࠡ⠥  ᫠  
//	  ॡ  ⠡ ᤢ.
//	᫨  ᪮ ,  㭪 ந ⠡ ᤢ,
//	 ਬ ,  ᯮ騩 ⠡ ᤢ.

void	cBigNumberMModTab (			// ⮪ p1 %= p2.
			EXPTR(long) p1,		// , ⮬ - ⮪.
		const	EXPTR(long) p2		// ⥫  ⠡ ᤢ.
	)                                       // p1  p2   ᮢ.
{
  assert (p1 != p2);
  assert (cBigNumberIsFit (p1));		// ଠ.
  assert (cBigNumberIsFit (p2));		// ଠ.

  size_t n1 = (size_t)(*p1);			// ᫮ ᫮.
  size_t n2 = (size_t)(*p2);	 		// ᫮ ᫮.
  size_t n = ((n1 > n2)? n1 - n2: 0) + 1;	// ᫮ ᫮  ⭮.

  assert ((p1 [n1] ^ p2 [n2]) >= 0);		//  .

//	⢥ .

  cBigNumberMSubD_skip0 (p2);			// ᫮ 0-᫮ p2.
  n2 += 2;					//  ⠡ ᤢ.
  if (cBigNumberNot0 (p2))			// ஢ઠ   0.
  {
    long lt = (p1 [n1] < 0) * 2 - 1;		// ⠭  ࠢ
						// ᮫ 祭 ᥫ
						// (p1 >= 0)? -1: 1
    const EXPTR(long) pp2 = p2;			// 稩 㪠⥫.
    do	 					//   ᫮ ⭮.
    {
      --n;					// 稪 ᫮ ⭮.
      pp2 += n2 * BITS;				//  ⥫  ᫮.
      unsigned long mask = (1L << (BITS-1));	// 砫쭠 ᪠.
      do					//   ⠬ ⭮.
      {
	pp2 -= n2;				// 騩 ᤢ.
	assert (*pp2 >= (long)(n2 - 2) && *pp2 <  (long) n2);
						//  ⠡ ᤢ?
	int diff = n - (size_t)(*p1)		//  ࠧ஢.
		     + (size_t)(*pp2);
	if (diff <= 0 && (diff < 0 ||		// ᫨ ⮪  
	    cBigNumberCompHigh (p1, pp2) != lt))// ᤢ⮣ ⥫,
	{					//  ஢
	  cBigNumberMSubD (p1, pp2, n);		// ⠭ ⥫.
	}
      }
      while ((mask >>= 1) != 0);		//  横  ⠬.
    }
    while (n);					//  横  ᫮.
    assert (cBigNumberComp (p1, pp2) == lt);	// ⮪  ⥫?
  }
  else						//   0.
  {						// ᫨   0
    cBigNumberDiv0();				// ࠧ襭,  ⮪
  }						// 㤥 ࠢ .
}

void	cBigNumberMMod (			// ⮪ p1 %= p2.
			EXPTR(long) p1,		// , ⮬ - ⮪.
		const	EXPTR(long) p2		// ⥫.
	)                                       // p1  p2  ᮢ.
{

//	⮢   ⥫: ஢ ଠ 
//	ᯥ稢 ᮢ .

  size_t n1 = (size_t) cBigNumberFit (p1);	// ᫮ ᫮.
  size_t n2 = (size_t)(*p2);	 		// ᫮ ᫮.

  cBigBuf2.checkexpand (exmul (BITS, n2 + 3));	// । ,
  EXPTR(long) pp2 = EXPTRTYPE(cBigBuf2);		//   ⥫.

  if ((p1 [n1] ^ p2 [n2]) >= 0)			//  ᮢ:
    { cBigNumberCopy (p2, pp2); }		// ஢ ⥫.
  else						//   ᮢ:
    { cBigNumberNeg  (p2, pp2); }		// ᬥ  ⥫.

  if (n1 > n2 + 1)				// ⨬஢ ਠ
  {						//  ⠡楩 ᤢ.
    cBigNumberTab (pp2);			// ⮢ ⠡ ᤢ.
    cBigNumberMModTab (p1, pp2);		// ⮪.
    return;
  }

  n2 = cBigNumberFit (pp2);			// ଠ ⥫.

  size_t n = ((n1 > n2)? n1 - n2: 0) + 1;	// ᫮ ᫮  ⭮
						// ( 業).
//	⢥ .

  cBigNumberMSubD_skip0 (p2);			// ᫮ 0-᫮ p2.
  if (cBigNumberNot0 (pp2))			// ஢ઠ   0.
  {
    long lt = (p1 [n1] < 0) * 2 - 1;		// ⠭  ࠢ
						// ᮫ 祭 ᥫ
						// (p1 >= 0)? -1: 1
    do	 					//   ᫮ ⭮.
    {
      --n;	 				// 稪 ᫮ ⭮.
      int ns = BITS - 1;			// 稪 ⮢ ᤢ pp2.
      cBigNumberMShlD (pp2);			//  ⥫  ᫮.
      do					//   ⠬ ⭮.
      {
	int diff = cBigNumberMDiv2 (pp2) + n -	//  ⥫  .
		   (size_t)(*p1);		//  ࠧ஢.
	if (diff <= 0 && (diff < 0 ||		// ᫨ ⮪  
	    cBigNumberCompHigh (p1, pp2) != lt))// ᤢ⮣ ⥫,
	{					//  ஢
	  cBigNumberMSubD (p1, pp2, n);		// ⠭ ⥫.
	}
      }
      while (--ns >= 0);			//  横  ⠬.
    }
    while (n);					//  横  ᫮.
    assert (cBigNumberComp (p1, pp2) == lt);	// ⮪  ⥫?
  }
  else						//   0.
  {						// ᫨   0
    cBigNumberDiv0();				// ࠧ襭,  ⮪
  }						// 㤥 ࠢ .
}

//================================================
//	㭪樨   ⥯.
//================================================

//	㭪   ⥯ ॡ, ⮡ ᭮
//	室   ⠪  ࠧ,     
//	१ 樨.  ᭮ ᯮ,  ࠡ稩.
//	 ஢   묨  ।⠢
//	१. ⬥⨬,  ᫨  p2   ᫮ 
//	p1 ⫨筮  -1,0,1,  ࠧ ஢ 㤥   512 M.
//	⥫ ⥯   ⥫.
//	㭪 ᥣ 뤠 ଠ ᫮.

void	cBigNumberPow (				//  p1  ⥯ p2.
			EXPTR(long) p1,		//   ᭮.
		const	EXPTR(long) p2,		// ⥫ >= 0.
			EXPTR(long) p		//   १.
	)                                       //    ᮢ
{						// p1 .
  size_t n2 = (size_t)(*p2);	 		// ᫮ ᫮.
  assert (p1 != p2);
  assert (p1 != p);
  assert (p2 != p);
  assert (p2 [n2] >= 0);			// ⥫쭮.

  p2++;
  p [0] = 1; p [1] = 1;				// 砫쭠 ⥯.
  if (n2)
  {
    for (;;)					//   ᫮ p2.
    {
      long num = *p2++;				// । ᫮ p2.
      long mask = 1;				// ᪠  ⮢ num.
      if (--n2 == 0)				// 頥 ᫮ 室
      {             				//  ᫥ 横.
	do                                      // 訩  num ᥣ 0.
	  mask <<= 1;			        //  mask  num, 
	while ((num <<= 1) > 0);		// 訩  num ࠢ 0.
	if (mask == 0) break;			// 襥 ᫮ p2 㫥.
      }
      for (;;)					//   ⠬ ᫮ p2.
      {
	if (num & mask)
	  cBigNumberMul(p1, p, p);		//  ⥯.
	if ((mask <<= 1) == 0) break;		//  稫.
	cBigNumberMul (p1, p1, p1);		//  ᭮.
      }						//  横  ⠬ p2.
      if (n2 == 0) break;			//  稫.
      cBigNumberMul (p1, p1, p1);		//  ᭮.
    }						//  横  ᫮ p2.
  }
}

//	㭪   ⥯   ॡ, ⮡ ᭮
//	室   㤢  ࠢ  㫥 ࠧ.
//	 ᭮ ᯮ,  ࠡ稩.
//	⥫ ⥯   ⥫.
//	㭪 ᥣ 뤠 ଠ ᫮.

void	cBigNumberPowMod (			//  p1  ⥯ p2.
			EXPTR(long) p1,		//   ᭮.
		const	EXPTR(long) p2,		// ⥫ >= 0.
		const	EXPTR(long) mod,	// .
			EXPTR(long) p		//   १.
	)                                       // p1,p2,p   ᮢ
{						// p1 .
  size_t n2 = (size_t)(*p2);	 		// ᫮ ᫮.
  assert (p1 != p);
  assert (p2 != p);
  assert (p1 != p2);
  assert (p2 [n2] >= 0);			// ⥫쭮.

  cBigBuf3.checkexpand (exmul (BITS, n2 + 3));	// । ,
  EXPTR(long) pmod = EXPTRTYPE(cBigBuf3);		//   ⥫.
  long signmod;					//  .
  if ((signmod = mod [(size_t)(*mod)]) >= 0)
    cBigNumberCopy (mod, pmod);			// ஢ .
  else
    cBigNumberNeg  (mod, pmod);			//   .
  cBigNumberTab (pmod);				// ⮢ ⠡ ᤢ.

  p2++;
  p [0] = 1; p [1] = 1;				// 砫쭠 ⥯.
  cBigNumberMModTab (p1, pmod);			//  ᭮.
  if (n2)
  {
    for (;;)					//   ᫮ p2.
    {
      long num = *p2++;				// । ᫮ p2.
      long mask = 1;				// ᪠  ⮢ num.
      if (--n2 == 0)				// 頥 ᫮ 室
      {             				//  ᫥ 横.
	do                                      // 訩  num ᥣ 0.
	  mask <<= 1;			        //  mask  num, 
	while ((num <<= 1) > 0);		// 訩  num ࠢ 0.
	if (mask == 0) break;			// 襥 ᫮ p2 㫥.
      }
      for (;;)					//   ⠬ ᫮ p2.
      {
	if (num & mask)
	{ 					//  ⥯.
	  if (*p1 > *p) cBigNumberMul (p1, p, p);
	  else          cBigNumberMul (p, p1, p);
          cBigNumberMModTab (p, pmod);		//  ⥯.
        }
	if ((mask <<= 1) == 0) break;		//  稫.
	cBigNumberMul  (p1, p1, p1);		//  ᭮.
	cBigNumberMModTab (p1, pmod);		//   ᭮.
      }						//  横  ⠬ p2.
      if (n2 == 0) break;			//  稫.
      cBigNumberMul  (p1, p1, p1);		//  ᭮.
      cBigNumberMModTab (p1, pmod);		//   ᭮.
    }						//  横  ᫮ p2.
  }
  if (signmod < 0) cBigNumberNeg (p, p);	//  .
}

#ifdef __cplusplus
}
#endif
