/*      cbignums.cpp

	 ᫠  ࠭祭 ࠧ來 ⪮.
	-뢮.

	(C) ..஢,   PAH, 1999 - 2000
	All Rights Reserved.
*/
#if __TURBOC__ > 0x410
#pragma option -xd-
#endif
#include <ctype.h>
#include <stdlib.h>
#include <iomanip.h>
#include <limits.h>
#include "cbignum.h"
#include <assert.h>

//	ᨬ쭮 ᭮ ⥯.

#define RADIX_MAX 16

//================================================
//	 .
//================================================

//	⮤ ॢ ப   ᫠ ࠡ⠥  ᭮
//	 2  16. ᫨ ᭮  㪠 (0),  ᭮
//	10, 8  16 롨ࠥ   䨪ᮢ 0  0x.

cBigNumber& cBigNumber::set (		// ८ࠧ  ப.
		const char *psz,	// 室 ப.
		size_t radix		// ᭮ (1..16)  0.
	    )				// 0 -  ᮣ襭 몠 .
{
  assert (radix != 1);
  assert (radix <= RADIX_MAX);
  assert (psz);
  int sign = 0;				//  ᫠.
  int c = *psz++;			// 騩 ᨬ.

  switch (c)				// ᯮ .
  {
    case '-': ++sign;
    case '+': c = *psz++;
  }

  if (radix == 0)			// ᯮ ᭮.
  {
    if (c == '0')
    {
      c = *psz++;
      radix = 8; if (c == 'X' || c == 'x') { c = *psz++; radix = 16; }
    }
    else radix = 10;
  }

  *this = 0;				//  .
  for (;;)
  {
    if      (isdigit (c)) { c -= '0';		}
    else if (isxdigit(c)) { c &= 31; c += 9;	}
    else break;
    if ((size_t)c >= radix) break;
    *this *= radix;
    *this += c;
    c = *psz++;
  }
  if (sign) this->neg();		// ᢮ .
  return *this;
}

//	ଠ஢  ஢  ᭮ ᫥ 䫠:
//	ios::skipws	ய 砫 ஡
//	ios::dec	᫮  ᭮ 10
//	ios::oct	᫮  ᭮ 8
//	ios::hex	᫮  ᭮ 16

istream& operator >> (istream& is, cBigNumber& b)
{
  assert (&is);
  assert (&b);
  int sign = 0;				//  ᫠.
  int c;				// 騩 ᨬ.
  long   flags = is.flags();		// .
  size_t radix = (               	// ᭮.
	 (flags & ios::dec)? 10:
	 (flags & ios::oct)? 8:
	 (flags & ios::hex)? 16: 0);

//	 ࢮ ᨬ  ய᪮ ஡ ᨬ,
//	᫨  ।ᬮ७ 䫠 ios::skipws.

  { char cc; is >> cc; c = cc; }

  switch (c)				// ᯮ .
  {
    case '-': ++sign;
    case '+': c = is.get();
  }
  if (radix == 0)			// ᯮ ᭮.
  {
    if (c == '0')
    {
      c = is.get();
      radix = 8; if (c == 'X' || c == 'x') { c = is.get(); radix = 16; }
    }
    else radix = 10;
  }

  b = 0;				//  .
  for (;;)
  {
    if      (isdigit (c)) { c -= '0';		}
    else if (isxdigit(c)) { c &= 31; c += 9;	}
    else break;
    if ((size_t)c >= radix) break;
    b *= radix;
    b += c;
    c = is.get();
  }
  is.putback ((char) c);		// ᯮ ᨬ.

  if (sign) b.neg();                    // ᢮ .
  return is;
}

//================================================
//	 뢮.
//================================================

//	⮤ ॢ  ᫠  ப ࠡ⠥ 
//	᭮  2  16  ਭ 䫠 ଠ஢  ios.
//	᫨ ᭮  㪠 (0),  ଠ஢ ஢
//	 ᭮ ᫥ 䫠:
//	ios::internal	  ᭮ ᫥, ᫮ ࠢ  
//			ᨬ ios::fill()  ios::width() ᨬ.
//	ios::dec	 ᫮  ᭮ 10 (㬮砭).
//	ios::oct	 ᫮  ᭮ 8
//	ios::hex	 ᫮  ᭮ 16
//	ios::showbase	 ਧ ᭮ (0  0x)
//	ios::showpos	뢮   ⥫ ᥫ
//	ios::uppercase	ய 㪢  ᥫ  ᭮ > 10.
//	᫨ ᭮ 㪠,  ᫮ 뢮   ଥ,
//	 ⮬ 䫠 ios:dec, ios::oct, ios::hex .

//	⮤ 뤠 㪠⥫   ப, 
//	९뢠   ୮ 맮 ⮤.
//	⮤   ⪠ ᫥ .

char*	cBigNumber::toatmp (		// ॢ  ப.
		size_t radix,		// ᭮ (2..16)  0.
		ios& os			// ଠ஢ ᫠  NULL.
	) const				// 뤠 㪠⥫  ᪨
{					// ନ஢ ப.
  assert (radix != 1);
  assert (radix <= RADIX_MAX);
  static cBigNumber _num;		//   ᫥.
  _num = *this; _num.fit();		// ଠ.
  static exarray<char> str;		// 稩 .
  size_t i = 0;				//   str.
  long flags = (&os? os.flags(): 0);	//  ଠ஢ ios.
//
//	롮 ⠡ ४஢ .
//
  static const char numtostr [2] [RADIX_MAX + 1] =
				 {{'0','1','2','3','4','5','6','7','8','9',
				   'a','b','c','d','e','f','x'},
				  {'0','1','2','3','4','5','6','7','8','9',
				   'A','B','C','D','E','F','X'}};
  register const EXPTR(char) ps = EXPTRTO (char,
			 numtostr [(flags & ios::uppercase) != 0],
			 sizeof (numtostr [0]));
//
//	뢮   䨪ᮢ.
//
  {
    long sign = _num.comp0();

    if (radix == 0)			// ᫨ ᭮  㪠,
    {					//  ⨯ ᫠  䫠.
      radix = ((flags & ios::hex)? 16: (flags & ios::oct)? 8: 10);
      if (radix != 10)			// ᫨ ᭮ 8  16, 
      {                                 //  ஢.
	if (sign < 0)
	{
	  ++(_num.e[0]);		// ⥫쭮 ᫮  ᤥ
	  _num.checkexpand (_num.length());// ⥫,  祣  
	  _num.e [_num.length()] = 0;	//  㫥 ᫮.
	}
	sign = 0;
      }
    }

    if (sign < 0)					// 뢮  '-'.
    {
      str [i++] = '-'; _num.neg();
    }
    else if (sign > 0 && (flags & ios::showpos))	// 뢮  '+'
    {
      str [i++] = '+';
    }

    if (radix % 8 == 0 && (flags & ios::showbase))	// 뢮 ᭮.
    {
      str [i++] = '0'; if (radix == 16) str [i++] = ps [16];
    }
  }
//
//	ନ஢ ᫠.
//
  {
    size_t j = i;			//  ࢮ .

//	砫 ந ᨢ   ⭮ 浪
//	 ᮪饭 ᫠   ਬ
//	  樥, 祭 ⥬ 
//	᭮  楫᫥ ⥯.
//	室 (⨬஢) 横 룫廊 ⠪:
//	do
//	{
//	  _num /= radix;
//	  str [i++] = ps [(int)cBigNumber::lastdivmod().loword()];
//	}
//	while (_num.comp0());
//
//	 ⠡ 樥⮢   ᭮ 뢠
//	樥  ᮮ⢥  楫᫥ ⥯.
//
    static const long maxradix [] [2] = {{ 0L,  1 },	//  0
					 { 1L,  1 },	//  1
				{ 1073741824L, 30 },	//  2
				{ 1162261467L, 19 },	//  3
				{ 1073741824L, 15 },	//  4
				{ 1220703125L, 13 },	//  5
				{  362797056L, 11 },	//  6
				{ 1977326743L, 11 },	//  7
				{ 1073741824L, 10 },	//  8
				{  387420489L,  9 },	//  9
				{ 1000000000L,  9 },	// 10
				{  214358881L,  8 },	// 11
				{  429981696L,  8 },	// 12
				{  815730721L,  8 },	// 13
				{ 1475789056L,  8 },	// 14
				{  170859375L,  7 },	// 15
				{  268435456L,  7 } };	// 16

//	 ⨬樨 뢮  ᥫ   ᭮
//	ᮧ ᨢ ⥫  १⠬ ᫥⥫쭮
//	 樥  .
//	  ⥫ ନ ⠡ ᤢ.
//	᫮ ⥫ NPOW_MAX ।   樨
//	६ 뢮 ᥫ ࠧ୮ 10000-1000000 .

    #define NPOW_MAX 7
    static exarray<cBigNumber> powradix [RADIX_MAX + 1];
						// ᨢ ⥫.
    static size_t npow [RADIX_MAX + 1];		// ᫮ ⥫  ᨢ.
    size_t np = 0;				//  ⥪饣 ⥫.

//	 ᨢ ⥫.

    if (npow [radix] == 0)
    {
      powradix [radix] [0] = maxradix [radix] [0];
      powradix [radix] [0].tab();		//  ᤢ.
      ++ npow [radix];
    }
    while (np < NPOW_MAX && powradix [radix] [np].length() * 2 < _num.length())
    {
      if (++np >= npow [radix])
      {
	powradix [radix] [np] = powradix [radix] [np - 1];
	powradix [radix] [np].pow2();		//  ⥫.
        powradix [radix] [np].tab();		//  ᤢ.
	++ npow [radix];
      }
    }

//	⢥ ନ஢ ᫠.
//	 ᭮ ⬠  ᫥⥫쭮 
//	室 ᫠  ⥫.
//	 १   訩 ⥫  ᮬ npmax
//	ࠧ ⭮  ⮪,    ⥫
//	 ᮬ npmax-1,  ..,   १  
//	訩 ⥫  ᮬ 0   ᫠,
//	㪫뢠騥  ࠧ來  long,  ८ࠧ
//	 ப ⥬ ᫥⥫쭮   radix.
//
//	襥 ⭮ ࠭  _num,   訥 
//	࠭  ᨢ  div  ᨢ ਧ kdiv.
//	ਧ ࠢ 1, ᫨  ᮮ⢥饬  div
//	室 ⭮. ࢮ砫쭮 ᨢ  .
//
//	
//	襥 ⭮     ⭮  _num 
//	⪠  div [npmax - 1]; div [npmax - 1]  c 
//	⭮  div [npmax - 1]  ⪠  div [npmax - 2]  ..
//	⪨ ⮪  ⭮   div [0] ८ࠧ 
//	ப;  室 ८ࠧ ⪠ ⭮ ࠭  div [0].
//	⭮ div [1] ७  div [0]   
//	稭 c div [0], ⮬ div [2] ७  div [1] 
//	  c div [1],  ..   襣 ⭮,
//	 ந 㬥襭 npmax    .
//
    {
      size_t npmax = np;			//  襣 ⥫.
      static exarray<cBigNumber> _div;		// ᨢ .
      static exarray<int>       _kdiv;		// ᨢ ਧ.
       _div.checkexpand (np);			// ⠭ ࠧ.
      _kdiv.checkexpand (np);			// ⠭ ࠧ.
      EXPTR (cBigNumber)  div = EXPTRTYPE(_div);	// ⥫ ᨢ .
      EXPTR (int)        kdiv = EXPTRTYPE(_kdiv);	// ⥫ ᨢ ਧ.
      EXPTR (cBigNumber) powr = EXPTRTYPE(powradix [radix]);
						// ⥫ ᨢ ⥫.
      size_t numlength = _num.length() >> 8;	// ண - .
      if (numlength <= 16) numlength = 0;

//	  .
//	८ࠧ  窨 ᫠, ஬ ᠬ ᫥ ⪠.

      for (;;)					//   .
      {
	if (np == npmax)			// 襥 ⭮.
	{

//	  襥 ⭮   ᮮ⢥騩 ⥫.
//	  ᫨ १  㫥   襣
//	  ⥫  0,   襣 ⥫ 㬥蠥
//	   横 ࠡ⪨ 襣 ⭮ .

	  if (numlength)			// ண - .
	  {
            cerr << "Formatted"
		 << setw (7) << (numlength - (_num.length() >> 8)) << "K of"
		 << setw (7) <<  numlength <<"K"
		 << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b"
		 << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b";
          }
	  _num.setdivtab (_num, powr [np]);	//  ⭮  _num
						//  ⪠  lastdivmod.
	  if (np)
	  {
	    if (_num.comp0() == 0)		// ᫨ १
	    {					// ࠢ 0, 
	      _num = cBigNumber::lastdivmod();	// ⮪ ⠭
	      npmax = --np;			// 訬 .
	      continue;				// ७ 横.
	    }
	  }
	  else					// 祭 訩 ⮪.
	  {
	    if (_num.comp0() == 0)		// ᫨  ᫥ ⮪,
	      break;				//   横.
	    kdiv [np] = 0;			// 뢮 ⮫쪮 ⮪.
	  }
	}
	else					//  ⭮.
	{
	  assert (np > 0);			// ஫.
	  assert (kdiv [np - 1] == 0);		// ஫.
	  if (kdiv [np] == 0)
	  {
	    ++np; continue;
	  }
	  div  [np - 1].setdivtab (div [np], powr [np - 1]);
	  kdiv [np - 1] = 1;			//  ⭮  div [np-1]
						//  ⪠  lastdivmod().
	  kdiv [np] = 0;			// div [np] ᢮.
	  --np;
	}					//   .

//	  ⪠ -   ⪠  0,
//	   ᮮ⢥騩 ⥫.

	if (np)
	do
	{
	  div  [np - 1].setdivtab (cBigNumber::lastdivmod(), powr [np - 1]);
	  kdiv [np - 1] = 1;			//  ⭮  div [np-1]
	}					//  ⪠  lastdivmod().
	while (--np);

//	 ࠡ⪨ 襣 ⪠  ⭮,
//	 㪫뢠  । ࠧ來 ⪨ long.
//	訩 ⮪   cBigNumber::lastdivmod(),
//	 襥 ⭮ -  div [0], ᫨  ⠬ .

	{
	  register long lnum;				// ⪮ 楫.
	  lnum = cBigNumber::lastdivmod().loword();	// 뢮 ⪠.
	  for (;;)					//  믮
	  {        					//  2 ࠧ.
	    register long knum = maxradix [radix] [1] - 1;
	    do					// 뢮 knum .
	    {
	      str [i++] = ps [ (int) (lnum % radix) ];// 뢮 .
	      lnum /= radix;
	    }
	    while (--knum);

	    assert (lnum < (long) radix);		// ஢ઠ.
	    str [i++] = ps [ (int) (lnum) ];		// ᫥ .

	    if (kdiv [0] == 0) break;			//  ⭮?
	    lnum = div [0].loword();			// 뢮 ⭮.
	    kdiv [0] = 0;				// div [0] ᢮.
	  }
	}
	if (npmax) np = 1;
      }							//   .
//
//	뢮 ᫥ ⪠.
//
      {
	long lnum = cBigNumber::lastdivmod().loword();
	if (lnum)					// ⪨ ⮪.
	do
	{
	  str [i++] = ps [ (int) (lnum % radix) ];	// 뢮 .
	}
	while ((lnum /= radix) != 0);
      }
      if (numlength)					// ⪠ .
            cerr << "                            "
		 << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b"
		 << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b";
//
//	뢮   㫥 ᥫ.
//
      if (i == j) str [i++] = ps [0];			// ᫮ ࠢ 0,

    }
//
//	뢮 ᨬ-⥫  襭 ப.
//
    {
      assert (i > j);			// ஫.
      if (flags & ios::internal)	// ଠ  ⥫?
      {
        size_t n = os.width();		// ਭ .
        char   c = os.fill();		// ⥫.
        while (i < n) str [i++] = c;	// 뢮 ⥫.
      }
      str [i--] = 0;			// ப ⮢.
    }
//
//	⠭ ᨬ.
//
    {
      register EXPTR(char) ps = EXPTRTYPE(str);

      while (i > j)			// ⠭ ᨬ.
      {
        char c = ps [j]; ps [j] = ps [i]; j++; ps [i] = c; i--;
      }
    }
  }
//
//	᫮ ନ஢.
//
  cBigNumber::lastdivmod() = 0;        	// 㫥  ᪫祭
				      	//  䥪⮢.
  return ((char *)(const char *)str);	// 뤠 ப.
}

//================================================
//	 ஢ -뢮.
//================================================

//	ଠ஢ 뢮 ஢  ᭮ ᫥ 䫠:
//	ios::width()	ਭ 
//	ios::fill()	ᨬ-⥫
//	ios::left  	ࠢ 
//	ios::right 	ࠢ ࠢ
//	ios::internal	  ᭮ ᫥, ᫮ ࠢ
//	ios::dec	 ᫮  ᭮ 10 (㬮砭).
//	ios::oct	 ᫮  ᭮ 8
//	ios::hex	 ᫮  ᭮ 16
//	ios::showbase	 ਧ ᭮ (0  0x)
//	ios::showpos	뢮   ⥫ ᥫ
//	ios::uppercase	ய 㪢  ᥫ  ᭮ > 10.
//	⮤   ⪠ ᫥ .

ostream& operator << (ostream& os, const cBigNumber& b)
{
  assert (&os);
  assert (&b);
  os << b.toatmp (0, os);
  return os;
}
