/*      exalloc.h

        ᪮ ।   ࠡ⪮ 訡.

	(C) ..஢,   PAH, 1994 - 2000
	All Rights Reserved.
*/
#ifndef _EXALLOC_H
#define _EXALLOC_H

#include <limits.h>

#ifndef __EXDEF_H
#include <exdef.h>
#endif

//------------------------------------------------
//	譨 뫪 ,  "C", ⮡
//	஢ ८ࠧ .
//	  ७ ꥪ 㫨
//	 ࠧ묨 ﬨ ஢.

#ifdef	__cplusplus
extern "C" {
#endif

//================================================
//	  । ᪮ .
//================================================
//	   த㡫஢
//	 㣨 砥 䠩,

#ifndef	_EXALLOC_MAIN
#define	_EXALLOC_MAIN

//------------------------------------------------
//	ࠬ । ᪮ ,
//	EXSIZE_T_MAX        - ᨬ쭮 祭,
//		뤠  ⢥ १
//		楫᫥ ᫥  ஫
//		९ ࠧ來 ⪨.
//	EXCALCBLOCKSIZE_SYS - ࠧ ⥬
//		  , 騩
//		 ਬ塞  (᫨
//		ࠧ ⥭,   㪠
//		 業,    16).
//	EXCALCBLOCKSIZE_MOD - 砫 ࠧ
//		   ⮬ ⥬
//		    
//		㭪樨 excalcblocksize, 
//		64**n +/- 16 .
//	EXCALCBLOCKSIZE1..5 -  砫 ࠧ
//		    ⥬
//		૮, ⠭  
//		㭪樨 excalcblocksize  ᪮쪮
//		᫥ ࠧ஢, 뤠
//		⮩  㭪樥.
//	EXCALCBLOCKSIZE_MAX - ᨬ ࠧ
//		    ⥬
//		,  ᪠
//		㭪ﬨ । 
//		(樮 ⥬  
//		 뢠 ⥫ 
//		࠭祭).

#define EXSIZE_T_MAX	    ((sizeof(size_t)==2)? UINT_MAX: INT_MAX)
#define EXCALCBLOCKSIZE_SYS (sizeof(size_t) * 2)
#define EXCALCBLOCKSIZE_MOD (sizeof(size_t) * 32 - 16)
#define EXCALCBLOCKSIZE_1   (EXCALCBLOCKSIZE_MOD * 1 - EXCALCBLOCKSIZE_SYS)
#define EXCALCBLOCKSIZE_2   (EXCALCBLOCKSIZE_MOD * 2 - EXCALCBLOCKSIZE_SYS)
#define EXCALCBLOCKSIZE_3   (EXCALCBLOCKSIZE_MOD * 3 - EXCALCBLOCKSIZE_SYS)
#define EXCALCBLOCKSIZE_4   (EXCALCBLOCKSIZE_MOD * 6 - EXCALCBLOCKSIZE_SYS)
#define EXCALCBLOCKSIZE_5   (EXCALCBLOCKSIZE_MOD * 9 - EXCALCBLOCKSIZE_SYS)
#define EXCALCBLOCKSIZE_MAX (EXSIZE_T_MAX - EXCALCBLOCKSIZE_SYS * 2)

//------------------------------------------------
//	᫥ ᫥  ஫
//	९ ࠧ來 ⪨.
//	  exmuladd (s,n,k) = s * n + k.
//	  exmul    (s,n)   = s * n.
//	  exadd    (n,k)   = n + k.
//	 樨 ⨬쭮  ᫥
//	⠢ ⠭   s  k.
//	 ९ 뤠 EXSIZE_T_MAX.

#ifdef	__cplusplus

inline	size_t	exmuladd (size_t s, size_t n, size_t k)
{
  return ((n <= (EXSIZE_T_MAX - k) / s)? (n * s + k): EXSIZE_T_MAX);
}

inline	size_t	exmul (size_t s, size_t n)
{
  return ((s == 1)? n: (n <= EXSIZE_T_MAX / s)? n * s: EXSIZE_T_MAX);
}

inline	size_t	exadd (size_t n, size_t k)
{
  return (exmuladd (1, n, k));
}

#else //__cplusplus

size_t	    STDECL exmuladd	(size_t s, size_t n, size_t k);	// s*n+k
size_t	    STDECL exmul	(size_t s, size_t n);		// s*n
size_t	    STDECL exadd	(size_t n, size_t k);		// n+k
#define	exmul(s,n)		exmuladd((s),(n),0)
#define exadd(n,k)		exmuladd(1,(n),(k))

#endif//__cplusplus

//------------------------------------------------
//	⥫ 㭪樨, 뢠 
//	訡 । .
//	㭪  㤨 ᪫祭
//	 ४ 믮 ணࠬ.
//	᫨ 㪠⥫ ࠢ NULL,  ࠡ⪠
//	믮 㭪樥, ⠭
//	 set_new_handler  new.h, ᫨ 
//	 ⠪ ,  뢠 abort().

extern	void (* VDECL _exalloc_fail_handler)(void);

//------------------------------------------------
//	㭪 excalcblocksize 뢠
//	⨬ ࠧ    ,
//	     ॡ㥬. 
//	᫨ 襭 ࠧ ᫨誮 ,
//	 뤠 EXSIZE_T_MAX.

size_t	STDECL	excalcblocksize (size_t size);

//------------------------------------------------
//	 exalloc  㭪 exmalloc
//	뤥  ,  ﬨ.
//
//	 exrealloc  㭪 exmrealloc
//	뤥, 㤫, 㪮稢 
//	᢮  ,  ⠪
//	  ⮪.
//
//	     .
//	 ९ ࠧ來 ⪨ 
//	 墠⪥  뢠 㭪,
//	᢮ _exalloc_fail_handler.
//	᫨ _exalloc_fail_handler == NULL,
//	 뢠 㭪, ⠭
//	 set_new_handler  new.h, ᫨ 
//	 ⠪ ,  뢠 abort().
//
//	㭪 exfree ᢮  .

#define exalloc(T,blocksize) ((T*) exmalloc (exmul (sizeof(T),(blocksize))))

#define exrealloc(T,p,blocksize,memset_start,memset_stop) (	\
		exmrealloc ((void**)&(p),			\
			exmul (sizeof(T), (blocksize)),		\
			sizeof(T) * (size_t)(memset_start),	\
			sizeof(T) * (size_t)(memset_stop)))

void*	STDECL	exmalloc   (size_t blocksize);
void	STDECL	exmrealloc (void** p, size_t blocksize,
			    size_t memset_start,
			    size_t memset_stop);
void	STDECL	exfree     (void* p);

//------------------------------------------------
//	⥫ ᪮ 㭪樨,
//	뢠  ⮬᪮ 㢥祭
//	ࠧ ᨢ  NULL, ᫨ 맮
//	᪮ 㭪樨  ॡ.
//	 ਬ  ஢
//	⮬᪮ 㢥祭 ࠧ.
//	ࢮ砫쭮 祭 - NULL.

extern	void (* VDECL _exalloc_auto_handler)(void);

//------------------------------------------------
//	⥫ 㭪樨, 뢠 
//	室   ࠭ ᨢ
//	 ⮬ 砥, ᫨  ।ᬮ७
//	⮬᪮ 㢥祭 ࠧ ᨢ.
//	㭪  㤨 ᪫祭
//	 ४ 믮 ணࠬ.

extern	void (* VDECL _exindex_range_handler)(void);

//------------------------------------------------
//	⥫ 㭪樨, 뢠 
//	饭  NULL-㪠⥫.
//	㭪  㤨 ᪫祭
//	 ४ 믮 ணࠬ.

extern	void (* VDECL _exnull_pointer_handler)(void);

#endif//_EXALLOC_MAIN

//================================================
//	ࠡ⪠ 訡  । .
//================================================

//------------------------------------------------
//	⠭ 㭪樨 ࠡ⪨ 訡.

void	STDECL	exalloc_fail 	    (void);	// _exalloc_fail_handler
void	STDECL	exindex_range_fail  (void);	// _exindex_range_handler
void	STDECL	exnull_pointer_fail (void);	// _exnull_pointer_handler

//------------------------------------------------
//	 ᫥ 襭  .
//	  訡 ࠧ饭.

extern	size_t	_exalloc_blocksize;

//------------------------------------------------
//	।   
//	ࠡ⪨ 訡  ࠡ⪨ ᪫祭.
//	exalloc_success(t,n)		- ⪠
//	exalloc_result(t)		- १

#define exalloc_success(t,n)	(exmalloc_success (exmul (sizeof(t),(n))))
#define exalloc_result(t)	((t*) exmalloc_result())
int	STDECL	exmalloc_success (size_t blocksize);
void*	STDECL	exmalloc_result  (void);

//------------------------------------------------
//	஫ 
//	(믮 ⮫쪮  16-ࠧ來 ०).
//	excoreleft()	- ᮮ ꥬ 
//	excore_store()	-  ꥬ 
//	excore_clear()	- 㫨  ꥬ 
//	excore_check()	- ஢ ꥬ 
//	㭪樨 excore  excore_check ᫥ 뢠
//	   ⮬  ஢  㭪権.

#ifndef __SEGMENT__
typedef	unsigned	excoreleft_t;
#else
typedef unsigned long	excoreleft_t;
#endif
excoreleft_t	STDECL	excoreleft (void);

#ifdef	__FLAT__
#define excore_store()
#define excore_clear()
#define excore_check()
#else //__FLAT__
void	STDECL	excore_store	(void);
void	STDECL	excore_clear	(void);
void	STDECL	excore_check	(void);
#endif//__FLAT__

//================================================
//	16-ࠧ來 㭪樨 । .
//================================================

#ifndef __STDC__
#ifndef	__FLAT__
void far* STDECL exfarmalloc	(unsigned long blocksize);
void      STDECL exfarmrealloc	(void far **lp, unsigned long blocksize,
				 unsigned long memset_start,
				 unsigned long memset_stop);
void	  STDECL exfarfree	(void far *lp);
#else //__FLAT__
#define	exfarmalloc	exmalloc
#define	exfarmrealloc	exmrealloc
#define	exfarfree	exfree
#endif//__FLAT__
#endif//__STDC__

//================================================
//	஢ ப  । .
//================================================

char*	STDECL	exstrdup	 (const char *src);

#ifdef __cplusplus
}
#endif

#endif//_EXALLOC_H
