
/*** Speech Driver error codes ***/
#define spkNOT_FOUND  1
#define spkERR_PARAM  2
#define spkERR_PATH   3
#define spkERR_FUNCT  4
#define spkERR_DEVICE 8
#define spkBRK_DETECT 0x80
#define spkDRV_BUSY   0xFFFF

/*** types definition ***/
#define BYTE unsigned char
#define WORD unsigned int
#define DWORD unsigned long
#define LPTR char far*

typedef struct {
unsigned char scancode;
unsigned char status;
} key_t;


/***  Speech Driver parameters block ***/
typedef struct {
WORD voice;
WORD tempo;
WORD volume;
WORD output;
struct {
 WORD num;
 DWORD min_max[];
 } far *pitch;
struct {
 WORD  num;
 key_t key[];
 } far *brk;
} SPKPARAM;

#ifdef __cplusplus
extern "C" {
#endif

/*** Speech Driver functions ***/
WORD far cdecl speak  (WORD length, LPTR string);
WORD far cdecl spkSetOutput (WORD output);
WORD far cdecl spkSetVoice  (WORD voice);
WORD far cdecl spkSetTempo  (WORD tempo);
WORD far cdecl spkSetVolume (WORD volume);
WORD far cdecl spkSetPitch  (WORD pitch_min, WORD pitch_max);
WORD far cdecl spkGetVer    (void);
SPKPARAM far* far cdecl spkGetCnf(void);
WORD far cdecl spkCont(void);
WORD far cdecl spkSetBrk (WORD, key_t far *);
key_t far cdecl spkGetKey (void);

#ifdef __cplusplus
}
#endif
