#pragma option -3		// 386 instructions
#ifdef	__TURBOC__
#pragma inline			// Use built-in assembler
#pragma option -r-		// No register variables
#pragma option -k-		// No standard stack frame
#pragma option -w-asm		// Enable unknown assemler instruction
#endif
#include <exdef.h>

#ifdef __SEGMENT__
int	STDECL	arifexp (const char *str)
{
  exprintfail ("Arifexp requires non-segmented memory model\n", str);
  return (0);
}
#else
/*-----------------------------------------------------------------------*
 * filename - arifexp.cas
 *
 *   ᫥ 䬥᪮ ࠦ.
 * ..ᥭ
 *
 * Usage           int arifexp (const char *str);
 *  ࠦ:  255 ᨬ. 樨: + - * / : % ^
 * 樨 ⮫쪮  楫묨 ᫠. ਬ: -200000/(30-20)
 * ஡ -  .
*------------------------------------------------------------------------*/

static const char* pszexp;			// 室 ப.

static void near ERROR  (void)
{
   exprintfail ("Too long expression: %s\n", pszexp);
}

static void near INVAL	(void)
{
   exprintfail ("Invalid expression: %s\n", pszexp);
}

static void near DIV0	(void)
{
   exprintfail ("Divide by 0 in expression: %s\n", pszexp);
}

static void near SKOB	(void)
// ᪮. ᫨ al='(' ,  edx=edx+1,  ᫨ al=')' ,  edx=edx-1
{
	__asm cmp    al,28h
	__asm jne    L1
	__asm inc    edx
L1:	__asm cmp    al,29h
	__asm jne    L2
	__asm dec    edx
L2:	__asm or     edx,edx
}

static void near SB3	(void)
{
//஢ઠ,  al ᮢ     * / : %
	__asm cmp    al,2Ah	// *
	__asm je     L
	__asm cmp    al,2Fh	// /
	__asm je     L
	__asm cmp    al,3Ah	// :
	__asm je     L
	__asm cmp    al,25h	// %
L:	return;
}

static void near SB6	(void)
//஢ઠ,  al ᮢ     + - ^ * / : %
{
	__asm cmp    al,2Bh	// +
	__asm je     L
	__asm cmp    al,2Dh	// -
	__asm je     L
	__asm cmp    al,5Eh	// ^
	__asm je     L
	__asm call   SB3
L:	return;
}

static void near MOVB  (void)
//⠢ ᨬ al   ebx  ࠡ.
{
	__asm mov    edi,ebx
L1:	__asm mov    cl,[edi]
	__asm mov    [edi],al
	__asm xchg   ecx,eax
	__asm inc    edi
	__asm cmp    edi,ebp
	__asm jb     L2
	__asm call   ERROR
L2:	__asm cmp    al,00h
	__asm jne    L1
	__asm mov    [edi],al
	return;
}

int	STDECL	arifexp (const char *psz)
{
   pszexp = psz;		//  ⨪   
				// । ࠬ  ⠢
// ESI = (unsigned int) psz;
#ifdef	__FLAT__
	__asm mov    esi, dword ptr psz;
#else
	__asm mov    si,  word ptr psz;
#endif
//   __asm mov edx,esi
//   __asm mov ah,40h
//   __asm mov ebx,1
//   __asm mov ecx,5
//   __asm int 21h
	__asm push ebp		// ନ.ࠡ.  ⥪:
	__asm mov    ebp,esp
	__asm sub    esp,0FFh
	__asm mov    edi,esp
	__asm mov    byte ptr [edi],28h
	__asm inc    edi
	__asm sub    edx,edx	//edx=0   ᪮

// ࠦ.  ࠡ.  ⥪:
L0012:	__asm lodsb
	__asm call   SKOB
	__asm jge     L0018
	__asm call INVAL		//  ")"  ᮮ⢥饩 "("
L0018:	__asm mov    [edi],al
	__asm cmp    al,25h	//  < 37 뢠
	__asm jb     L0020  
	__asm inc    edi
L0020:	__asm cmp    edi,ebp
	__asm jb     L0024
	__asm call ERROR
L0024:	__asm cmp    al,00h
	__asm jne    L0012  
	__asm mov    [edi],al
	__asm or     edx,edx
	__asm je     L0030
	__asm call INVAL		//  "(" , 祬 ")"

// "0" , ᫨ ࠦ. 砫  +  - :
L0030:	__asm mov    ebx,esp
L0032:	__asm inc    ebx
	__asm mov    al,[ebx]
	__asm cmp    al,00h
	__asm je     L0055  
	__asm call   SB6  
	__asm jne    L0032  
	__asm cmp    byte ptr [ebx-1],28h
	__asm jne    L0032  
	__asm cmp    al,2Bh	// al = '+'?
	__asm je     L004E  
	__asm cmp    al,2Dh	// al = '-'?
	__asm je     L004E    
	__asm call INVAL	// ࠦ.砫  ୮  樨
L004E:	__asm mov    al,30h
	__asm call   MOVB  
	__asm jmp    L0032

// 㣫 ᪮: 
L0055:	__asm mov    esi,0001h
L0058:	__asm mov    ebx,esp
L005A:	__asm inc    ebx
	__asm mov    al,[ebx]
	__asm cmp    al,00h
	__asm je     L00B8  
	__asm or     esi,esi
	__asm je     L0069  
	__asm cmp    al,5Eh
	__asm jmp    L006C  
L0069:	__asm call   SB3  
L006C:	__asm jne    L005A  
	__asm push   ebx
	__asm sub    edx,edx
L0071:	__asm dec    ebx
	__asm mov    al,[ebx]
	__asm call   SKOB  
	__asm jg     L00B5  
	__asm jl     L0071  
	__asm call   SB6  
	__asm jne    L0071
	__asm or     esi,esi
	__asm jne    L0090
	__asm cmp    al,2Ah
	__asm je     L0092
	__asm cmp    al,25h	//	%
	__asm je     L0092  
	__asm cmp    al,2Fh	//	/
	__asm je     L0092
	__asm cmp    al,3Ah	//	:
	__asm je     L0092
L0090:	__asm cmp    al,5Eh	//	^
L0092:	__asm je     L00B5  
	__asm inc    ebx
	__asm mov    al,28h
	__asm call   MOVB  
	__asm pop    ebx
	__asm inc    ebx
	__asm push   ebx
L009D:	__asm inc    ebx
	__asm mov    al,[ebx]
	__asm cmp    al,00h
	__asm je     L00B0  
	__asm call   SKOB  
	__asm jl     L00B0  
	__asm jg     L009D  
	__asm call   SB6  
	__asm jne    L009D  
L00B0:	__asm mov    al,29h
	__asm call   MOVB
L00B5:	__asm pop    ebx
	__asm jmp    L005A
L00B8:	__asm dec    esi
	__asm jge    L0058


//᭮ 横:
	__asm sub    ebp,ebp	// ebp  ⥪. 樨
	__asm mov    esi,esp
	__asm inc    esi
L00C0:	__asm lodsb		// al = । ᨬ ࠦ
	__asm cmp    al,00h	// ᫨ al=0,   ࠦ
	__asm jne L00C7
	__asm jmp L0174  
L00C7:	__asm call   SB6  
	__asm jne    L00D9  
	__asm mov    ebp,eax
	__asm mov    al,[esi]
	__asm call   SB6  
	__asm jne    L00C0  
	__asm call   INVAL		//   樨 
L00D9:	__asm cmp    al,29h
	__asm jne    L00E2  
	__asm pop    ecx
	__asm pop    ebp
	__asm push   ecx
	__asm jmp    L010C  
L00E2:	__asm cmp    al,28h
	__asm jne    L00EB  
	__asm push   ebp
	__asm sub    ebp,ebp
	__asm jmp    L010C  
L00EB:	__asm dec    esi
	__asm mov    ebx,esi
L00EE:	__asm inc    esi
	__asm mov    al,[esi]
	__asm cmp    al,00h
	__asm je     L00FA  
	__asm cmp    al,28h
	__asm je     L00F8  
	__asm cmp    al,29h
	__asm je     L00F8  
	__asm call   SB6
L00F8:	__asm jne    L00EE  
L00FA:	__asm sub    eax,eax
	__asm cdq

// ॢ ⥪ (  ebx   esi-1)  ᫮  edx
L00FD:	__asm mov    al,[ebx]
	__asm cmp    al,30h
	__asm jb     L00FE
	__asm cmp    al,39h
	__asm jbe    L00FF
	__asm inc    ebx
	__asm jmp    L0107
L00FE:	__asm call INVAL		//   ன
L00FF:	__asm inc    ebx
	__asm sub    al,30h
	__asm imul   edx,edx,0Ah
	__asm add    edx,eax
L0107:	__asm cmp    ebx,esi
	__asm jb     L00FD

	__asm push   edx
L010C:	__asm mov    eax,ebp
	__asm cmp    al,00h
	__asm jne    L0111
	__asm jmp    L00C0
L0111:	__asm mov    ebx,esp
	__asm push   eax
	__asm sub    ebx,esp // 16 ࠧ冷 ebx=2,  32 - ebx=4
	__asm pop    eax  
	__asm mov    edi,esp
	__asm add    ebx,esp
	__asm cmp    al,2Bh	// +
	__asm jne    L0126  
	__asm mov    eax,[edi]
	__asm add    [ebx],eax	// 
	__asm jmp    L0170  
L0126:	__asm cmp    al,2Dh	// -
	__asm jne    L0130  
	__asm mov    eax,[edi]
	__asm sub    [ebx],eax	// ⠭
	__asm jmp    L0170  
L0130:	__asm cmp    al,2Ah	// *
	__asm jne    L013A  
	__asm mov    eax,[ebx]
	__asm imul   dword ptr [edi]	// 
	__asm jmp    L016E 
L013A:	__asm cmp    al,3Ah	// :
	__asm je     L013E 
	__asm cmp    al,2Fh	// /
	__asm jne    L0145  
L013E:	__asm mov    eax,[ebx]
	__asm cdq
	__asm cmp    dword ptr [edi],0h
	__asm jne    L0141
	__asm call DIV0
L0141:	__asm idiv    dword ptr [edi]	// 
	__asm jmp    L016E  
L0145: __asm cmp    al,25h	// %
	__asm jne    L0152  
	__asm mov    eax,[ebx]
	__asm cdq
	__asm idiv    dword ptr [edi]
	__asm mov    [ebx],edx
	__asm jmp    L0170  
L0152:	__asm mov    ecx,[edi]	// ^
	__asm dec    ecx
	__asm mov    eax,[ebx]
	__asm je     L0170  
	__asm jl     L0162  
L015B:	__asm imul   dword ptr [ebx]
	__asm dec    ecx
	__asm jne    L015B  
	__asm jmp    L016E  
L0162:	__asm push   ebx
	__asm xchg   ebx,eax
	__asm sub    eax,eax
	__asm inc    eax
L0167:	__asm cdq
	__asm idiv   ebx
	__asm inc    ecx
	__asm jne    L0167  
	__asm pop    ebx
L016E:	__asm mov    [ebx],eax
L0170:	__asm pop    eax
	__asm jmp    L00C0  
L0174:	__asm pop    eax
	__asm add    esp,0FFh

   __asm pop ebp
   return EAX;
}
#endif
